package bookmarks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDBookmarksFoldersReader is a Reader for the GetCharactersCharacterIDBookmarksFolders structure.
type GetCharactersCharacterIDBookmarksFoldersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDBookmarksFoldersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDBookmarksFoldersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDBookmarksFoldersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDBookmarksFoldersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDBookmarksFoldersOK creates a GetCharactersCharacterIDBookmarksFoldersOK with default headers values
func NewGetCharactersCharacterIDBookmarksFoldersOK() *GetCharactersCharacterIDBookmarksFoldersOK {
	return &GetCharactersCharacterIDBookmarksFoldersOK{}
}

/*GetCharactersCharacterIDBookmarksFoldersOK handles this case with default header values.

List of bookmark folders
*/
type GetCharactersCharacterIDBookmarksFoldersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDBookmarksFoldersOKBodyItems0
}

func (o *GetCharactersCharacterIDBookmarksFoldersOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/folders/][%d] getCharactersCharacterIdBookmarksFoldersOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksFoldersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBookmarksFoldersForbidden creates a GetCharactersCharacterIDBookmarksFoldersForbidden with default headers values
func NewGetCharactersCharacterIDBookmarksFoldersForbidden() *GetCharactersCharacterIDBookmarksFoldersForbidden {
	return &GetCharactersCharacterIDBookmarksFoldersForbidden{}
}

/*GetCharactersCharacterIDBookmarksFoldersForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDBookmarksFoldersForbidden struct {
	Payload GetCharactersCharacterIDBookmarksFoldersForbiddenBody
}

func (o *GetCharactersCharacterIDBookmarksFoldersForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/folders/][%d] getCharactersCharacterIdBookmarksFoldersForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksFoldersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBookmarksFoldersInternalServerError creates a GetCharactersCharacterIDBookmarksFoldersInternalServerError with default headers values
func NewGetCharactersCharacterIDBookmarksFoldersInternalServerError() *GetCharactersCharacterIDBookmarksFoldersInternalServerError {
	return &GetCharactersCharacterIDBookmarksFoldersInternalServerError{}
}

/*GetCharactersCharacterIDBookmarksFoldersInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDBookmarksFoldersInternalServerError struct {
	Payload GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody
}

func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/bookmarks/folders/][%d] getCharactersCharacterIdBookmarksFoldersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDBookmarksFoldersForbiddenBody get_characters_character_id_bookmarks_folders_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDBookmarksFoldersForbiddenBody
*/
type GetCharactersCharacterIDBookmarksFoldersForbiddenBody struct {

	// get_characters_character_id_bookmarks_folders_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID bookmarks folders forbidden body
func (o *GetCharactersCharacterIDBookmarksFoldersForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDBookmarksFoldersForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdBookmarksFoldersForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBookmarksFoldersForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody get_characters_character_id_bookmarks_folders_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody
*/
type GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody struct {

	// get_characters_character_id_bookmarks_folders_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID bookmarks folders internal server error body
func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdBookmarksFoldersInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBookmarksFoldersInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDBookmarksFoldersOKBodyItems0 get_characters_character_id_bookmarks_folders_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDBookmarksFoldersOKBodyItems0
*/
type GetCharactersCharacterIDBookmarksFoldersOKBodyItems0 struct {

	// get_characters_character_id_bookmarks_folders_folder_id
	//
	// folder_id integer
	FolderID int32 `json:"folder_id,omitempty"`

	// get_characters_character_id_bookmarks_folders_name
	//
	// name string
	Name string `json:"name,omitempty"`

	// get_characters_character_id_bookmarks_folders_owner_id
	//
	// owner_id integer
	OwnerID int32 `json:"owner_id,omitempty"`
}

// Validate validates this get characters character ID bookmarks folders o k body items0
func (o *GetCharactersCharacterIDBookmarksFoldersOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBookmarksFoldersOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBookmarksFoldersOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
