package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDBlueprintsReader is a Reader for the GetCharactersCharacterIDBlueprints structure.
type GetCharactersCharacterIDBlueprintsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDBlueprintsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDBlueprintsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDBlueprintsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDBlueprintsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDBlueprintsOK creates a GetCharactersCharacterIDBlueprintsOK with default headers values
func NewGetCharactersCharacterIDBlueprintsOK() *GetCharactersCharacterIDBlueprintsOK {
	return &GetCharactersCharacterIDBlueprintsOK{}
}

/*GetCharactersCharacterIDBlueprintsOK handles this case with default header values.

A list of blueprints
*/
type GetCharactersCharacterIDBlueprintsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDBlueprintsOKBodyItems0
}

func (o *GetCharactersCharacterIDBlueprintsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBlueprintsForbidden creates a GetCharactersCharacterIDBlueprintsForbidden with default headers values
func NewGetCharactersCharacterIDBlueprintsForbidden() *GetCharactersCharacterIDBlueprintsForbidden {
	return &GetCharactersCharacterIDBlueprintsForbidden{}
}

/*GetCharactersCharacterIDBlueprintsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDBlueprintsForbidden struct {
	Payload GetCharactersCharacterIDBlueprintsForbiddenBody
}

func (o *GetCharactersCharacterIDBlueprintsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDBlueprintsInternalServerError creates a GetCharactersCharacterIDBlueprintsInternalServerError with default headers values
func NewGetCharactersCharacterIDBlueprintsInternalServerError() *GetCharactersCharacterIDBlueprintsInternalServerError {
	return &GetCharactersCharacterIDBlueprintsInternalServerError{}
}

/*GetCharactersCharacterIDBlueprintsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDBlueprintsInternalServerError struct {
	Payload GetCharactersCharacterIDBlueprintsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDBlueprintsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/blueprints/][%d] getCharactersCharacterIdBlueprintsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDBlueprintsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDBlueprintsForbiddenBody get_characters_character_id_blueprints_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDBlueprintsForbiddenBody
*/
type GetCharactersCharacterIDBlueprintsForbiddenBody struct {

	// get_characters_character_id_blueprints_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID blueprints forbidden body
func (o *GetCharactersCharacterIDBlueprintsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDBlueprintsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdBlueprintsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBlueprintsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDBlueprintsInternalServerErrorBody get_characters_character_id_blueprints_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDBlueprintsInternalServerErrorBody
*/
type GetCharactersCharacterIDBlueprintsInternalServerErrorBody struct {

	// get_characters_character_id_blueprints_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID blueprints internal server error body
func (o *GetCharactersCharacterIDBlueprintsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDBlueprintsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdBlueprintsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBlueprintsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDBlueprintsOKBodyItems0 get_characters_character_id_blueprints_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDBlueprintsOKBodyItems0
*/
type GetCharactersCharacterIDBlueprintsOKBodyItems0 struct {

	// get_characters_character_id_blueprints_item_id
	//
	// Unique ID for this item. The ID of an item is stable if that item is not repackaged, stacked, detached from a stack, assembled, or otherwise altered. If an item is changed in one of these ways, then the ID will also change (see notes below).
	// Required: true
	ItemID *int64 `json:"item_id"`

	// get_characters_character_id_blueprints_location_flag
	//
	// Indicates something about this item's storage location. The flag is used to differentiate between hangar divisions, drone bay, fitting location, and similar.
	// Required: true
	LocationFlag *string `json:"location_flag"`

	// get_characters_character_id_blueprints_location_id
	//
	// References a solar system, station or itemID if this blueprint is located within a container. If an itemID the Character - AssetList API must be queried to find the container using the itemID, from which the correct location of the Blueprint can be derived.
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_characters_character_id_blueprints_material_efficiency
	//
	// Material Efficiency Level of the blueprint, can be any integer between 0 and 10.
	// Required: true
	MaterialEfficiency *int32 `json:"material_efficiency"`

	// get_characters_character_id_blueprints_quantity
	//
	// Typically will be -1 or -2 designating a singleton item, where -1 is an original and -2 is a copy. It can be a positive integer if it is a stack of blueprint originals fresh from the market (no activities performed on them yet).
	// Required: true
	Quantity *int32 `json:"quantity"`

	// get_characters_character_id_blueprints_runs
	//
	// Number of runs remaining if the blueprint is a copy, -1 if it is an original.
	// Required: true
	Runs *int32 `json:"runs"`

	// get_characters_character_id_blueprints_time_efficiency
	//
	// Time Efficiency Level of the blueprint, can be any even integer between 0 and 20.
	// Required: true
	TimeEfficiency *int32 `json:"time_efficiency"`

	// get_characters_character_id_blueprints_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

// Validate validates this get characters character ID blueprints o k body items0
func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateItemID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLocationFlag(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLocationID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateMaterialEfficiency(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateQuantity(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRuns(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTimeEfficiency(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTypeID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateItemID(formats strfmt.Registry) error {

	if err := validate.Required("item_id", "body", o.ItemID); err != nil {
		return err
	}

	return nil
}

var getCharactersCharacterIdBlueprintsOKBodyItems0TypeLocationFlagPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["AutoFit","Cargo","CorpseBay","DroneBay","FleetHangar","Deliveries","HiddenModifiers","Hangar","HangarAll","LoSlot0","LoSlot1","LoSlot2","LoSlot3","LoSlot4","LoSlot5","LoSlot6","LoSlot7","MedSlot0","MedSlot1","MedSlot2","MedSlot3","MedSlot4","MedSlot5","MedSlot6","MedSlot7","HiSlot0","HiSlot1","HiSlot2","HiSlot3","HiSlot4","HiSlot5","HiSlot6","HiSlot7","AssetSafety","Locked","Unlocked","Implant","QuafeBay","RigSlot0","RigSlot1","RigSlot2","RigSlot3","RigSlot4","RigSlot5","RigSlot6","RigSlot7","ShipHangar","SpecializedFuelBay","SpecializedOreHold","SpecializedGasHold","SpecializedMineralHold","SpecializedSalvageHold","SpecializedShipHold","SpecializedSmallShipHold","SpecializedMediumShipHold","SpecializedLargeShipHold","SpecializedIndustrialShipHold","SpecializedAmmoHold","SpecializedCommandCenterHold","SpecializedPlanetaryCommoditiesHold","SpecializedMaterialBay","SubSystemSlot0","SubSystemSlot1","SubSystemSlot2","SubSystemSlot3","SubSystemSlot4","SubSystemSlot5","SubSystemSlot6","SubSystemSlot7","FighterBay","FighterTube0","FighterTube1","FighterTube2","FighterTube3","FighterTube4","Module"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		getCharactersCharacterIdBlueprintsOKBodyItems0TypeLocationFlagPropEnum = append(getCharactersCharacterIdBlueprintsOKBodyItems0TypeLocationFlagPropEnum, v)
	}
}

const (
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagAutoFit captures enum value "AutoFit"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagAutoFit string = "AutoFit"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagCargo captures enum value "Cargo"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagCargo string = "Cargo"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagCorpseBay captures enum value "CorpseBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagCorpseBay string = "CorpseBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagDroneBay captures enum value "DroneBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagDroneBay string = "DroneBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFleetHangar captures enum value "FleetHangar"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFleetHangar string = "FleetHangar"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagDeliveries captures enum value "Deliveries"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagDeliveries string = "Deliveries"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiddenModifiers captures enum value "HiddenModifiers"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiddenModifiers string = "HiddenModifiers"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHangar captures enum value "Hangar"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHangar string = "Hangar"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHangarAll captures enum value "HangarAll"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHangarAll string = "HangarAll"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot0 captures enum value "LoSlot0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot0 string = "LoSlot0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot1 captures enum value "LoSlot1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot1 string = "LoSlot1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot2 captures enum value "LoSlot2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot2 string = "LoSlot2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot3 captures enum value "LoSlot3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot3 string = "LoSlot3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot4 captures enum value "LoSlot4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot4 string = "LoSlot4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot5 captures enum value "LoSlot5"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot5 string = "LoSlot5"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot6 captures enum value "LoSlot6"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot6 string = "LoSlot6"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot7 captures enum value "LoSlot7"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLoSlot7 string = "LoSlot7"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot0 captures enum value "MedSlot0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot0 string = "MedSlot0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot1 captures enum value "MedSlot1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot1 string = "MedSlot1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot2 captures enum value "MedSlot2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot2 string = "MedSlot2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot3 captures enum value "MedSlot3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot3 string = "MedSlot3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot4 captures enum value "MedSlot4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot4 string = "MedSlot4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot5 captures enum value "MedSlot5"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot5 string = "MedSlot5"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot6 captures enum value "MedSlot6"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot6 string = "MedSlot6"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot7 captures enum value "MedSlot7"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagMedSlot7 string = "MedSlot7"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot0 captures enum value "HiSlot0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot0 string = "HiSlot0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot1 captures enum value "HiSlot1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot1 string = "HiSlot1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot2 captures enum value "HiSlot2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot2 string = "HiSlot2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot3 captures enum value "HiSlot3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot3 string = "HiSlot3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot4 captures enum value "HiSlot4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot4 string = "HiSlot4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot5 captures enum value "HiSlot5"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot5 string = "HiSlot5"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot6 captures enum value "HiSlot6"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot6 string = "HiSlot6"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot7 captures enum value "HiSlot7"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagHiSlot7 string = "HiSlot7"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagAssetSafety captures enum value "AssetSafety"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagAssetSafety string = "AssetSafety"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLocked captures enum value "Locked"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagLocked string = "Locked"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagUnlocked captures enum value "Unlocked"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagUnlocked string = "Unlocked"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagImplant captures enum value "Implant"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagImplant string = "Implant"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagQuafeBay captures enum value "QuafeBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagQuafeBay string = "QuafeBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot0 captures enum value "RigSlot0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot0 string = "RigSlot0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot1 captures enum value "RigSlot1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot1 string = "RigSlot1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot2 captures enum value "RigSlot2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot2 string = "RigSlot2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot3 captures enum value "RigSlot3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot3 string = "RigSlot3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot4 captures enum value "RigSlot4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot4 string = "RigSlot4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot5 captures enum value "RigSlot5"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot5 string = "RigSlot5"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot6 captures enum value "RigSlot6"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot6 string = "RigSlot6"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot7 captures enum value "RigSlot7"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagRigSlot7 string = "RigSlot7"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagShipHangar captures enum value "ShipHangar"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagShipHangar string = "ShipHangar"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedFuelBay captures enum value "SpecializedFuelBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedFuelBay string = "SpecializedFuelBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedOreHold captures enum value "SpecializedOreHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedOreHold string = "SpecializedOreHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedGasHold captures enum value "SpecializedGasHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedGasHold string = "SpecializedGasHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMineralHold captures enum value "SpecializedMineralHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMineralHold string = "SpecializedMineralHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedSalvageHold captures enum value "SpecializedSalvageHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedSalvageHold string = "SpecializedSalvageHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedShipHold captures enum value "SpecializedShipHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedShipHold string = "SpecializedShipHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedSmallShipHold captures enum value "SpecializedSmallShipHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedSmallShipHold string = "SpecializedSmallShipHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMediumShipHold captures enum value "SpecializedMediumShipHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMediumShipHold string = "SpecializedMediumShipHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedLargeShipHold captures enum value "SpecializedLargeShipHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedLargeShipHold string = "SpecializedLargeShipHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedIndustrialShipHold captures enum value "SpecializedIndustrialShipHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedIndustrialShipHold string = "SpecializedIndustrialShipHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedAmmoHold captures enum value "SpecializedAmmoHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedAmmoHold string = "SpecializedAmmoHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedCommandCenterHold captures enum value "SpecializedCommandCenterHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedCommandCenterHold string = "SpecializedCommandCenterHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedPlanetaryCommoditiesHold captures enum value "SpecializedPlanetaryCommoditiesHold"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedPlanetaryCommoditiesHold string = "SpecializedPlanetaryCommoditiesHold"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMaterialBay captures enum value "SpecializedMaterialBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSpecializedMaterialBay string = "SpecializedMaterialBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot0 captures enum value "SubSystemSlot0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot0 string = "SubSystemSlot0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot1 captures enum value "SubSystemSlot1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot1 string = "SubSystemSlot1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot2 captures enum value "SubSystemSlot2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot2 string = "SubSystemSlot2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot3 captures enum value "SubSystemSlot3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot3 string = "SubSystemSlot3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot4 captures enum value "SubSystemSlot4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot4 string = "SubSystemSlot4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot5 captures enum value "SubSystemSlot5"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot5 string = "SubSystemSlot5"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot6 captures enum value "SubSystemSlot6"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot6 string = "SubSystemSlot6"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot7 captures enum value "SubSystemSlot7"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagSubSystemSlot7 string = "SubSystemSlot7"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterBay captures enum value "FighterBay"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterBay string = "FighterBay"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube0 captures enum value "FighterTube0"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube0 string = "FighterTube0"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube1 captures enum value "FighterTube1"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube1 string = "FighterTube1"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube2 captures enum value "FighterTube2"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube2 string = "FighterTube2"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube3 captures enum value "FighterTube3"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube3 string = "FighterTube3"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube4 captures enum value "FighterTube4"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagFighterTube4 string = "FighterTube4"
	// GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagModule captures enum value "Module"
	GetCharactersCharacterIDBlueprintsOKBodyItems0LocationFlagModule string = "Module"
)

// prop value enum
func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateLocationFlagEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, getCharactersCharacterIdBlueprintsOKBodyItems0TypeLocationFlagPropEnum); err != nil {
		return err
	}
	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateLocationFlag(formats strfmt.Registry) error {

	if err := validate.Required("location_flag", "body", o.LocationFlag); err != nil {
		return err
	}

	// value enum
	if err := o.validateLocationFlagEnum("location_flag", "body", *o.LocationFlag); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateLocationID(formats strfmt.Registry) error {

	if err := validate.Required("location_id", "body", o.LocationID); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateMaterialEfficiency(formats strfmt.Registry) error {

	if err := validate.Required("material_efficiency", "body", o.MaterialEfficiency); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateQuantity(formats strfmt.Registry) error {

	if err := validate.Required("quantity", "body", o.Quantity); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateRuns(formats strfmt.Registry) error {

	if err := validate.Required("runs", "body", o.Runs); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateTimeEfficiency(formats strfmt.Registry) error {

	if err := validate.Required("time_efficiency", "body", o.TimeEfficiency); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) validateTypeID(formats strfmt.Registry) error {

	if err := validate.Required("type_id", "body", o.TypeID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDBlueprintsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDBlueprintsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
