package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersNamesReader is a Reader for the GetCharactersNames structure.
type GetCharactersNamesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersNamesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersNamesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetCharactersNamesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersNamesOK creates a GetCharactersNamesOK with default headers values
func NewGetCharactersNamesOK() *GetCharactersNamesOK {
	return &GetCharactersNamesOK{}
}

/*GetCharactersNamesOK handles this case with default header values.

List of id/name associations
*/
type GetCharactersNamesOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersNamesOKBodyItems0
}

func (o *GetCharactersNamesOK) Error() string {
	return fmt.Sprintf("[GET /characters/names/][%d] getCharactersNamesOK  %+v", 200, o.Payload)
}

func (o *GetCharactersNamesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersNamesInternalServerError creates a GetCharactersNamesInternalServerError with default headers values
func NewGetCharactersNamesInternalServerError() *GetCharactersNamesInternalServerError {
	return &GetCharactersNamesInternalServerError{}
}

/*GetCharactersNamesInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersNamesInternalServerError struct {
	Payload GetCharactersNamesInternalServerErrorBody
}

func (o *GetCharactersNamesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/names/][%d] getCharactersNamesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersNamesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersNamesInternalServerErrorBody get_characters_names_internal_server_error
//
// Internal server error
swagger:model GetCharactersNamesInternalServerErrorBody
*/
type GetCharactersNamesInternalServerErrorBody struct {

	// get_characters_names_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters names internal server error body
func (o *GetCharactersNamesInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersNamesInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersNamesInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersNamesInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersNamesInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersNamesInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersNamesOKBodyItems0 get_characters_names_200_ok
//
// 200 ok object
swagger:model GetCharactersNamesOKBodyItems0
*/
type GetCharactersNamesOKBodyItems0 struct {

	// get_characters_names_character_id
	//
	// character_id integer
	// Required: true
	CharacterID *int64 `json:"character_id"`

	// get_characters_names_character_name
	//
	// character_name string
	// Required: true
	CharacterName *string `json:"character_name"`
}

// Validate validates this get characters names o k body items0
func (o *GetCharactersNamesOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCharacterID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateCharacterName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersNamesOKBodyItems0) validateCharacterID(formats strfmt.Registry) error {

	if err := validate.Required("character_id", "body", o.CharacterID); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersNamesOKBodyItems0) validateCharacterName(formats strfmt.Registry) error {

	if err := validate.Required("character_name", "body", o.CharacterName); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersNamesOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersNamesOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersNamesOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
