package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// PostCharactersAffiliationReader is a Reader for the PostCharactersAffiliation structure.
type PostCharactersAffiliationReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCharactersAffiliationReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewPostCharactersAffiliationOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 422:
		result := NewPostCharactersAffiliationUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewPostCharactersAffiliationInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostCharactersAffiliationOK creates a PostCharactersAffiliationOK with default headers values
func NewPostCharactersAffiliationOK() *PostCharactersAffiliationOK {
	return &PostCharactersAffiliationOK{}
}

/*PostCharactersAffiliationOK handles this case with default header values.

Character corporation, alliance and faction IDs
*/
type PostCharactersAffiliationOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*PostCharactersAffiliationOKBodyItems0
}

func (o *PostCharactersAffiliationOK) Error() string {
	return fmt.Sprintf("[POST /characters/affiliation/][%d] postCharactersAffiliationOK  %+v", 200, o.Payload)
}

func (o *PostCharactersAffiliationOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCharactersAffiliationUnprocessableEntity creates a PostCharactersAffiliationUnprocessableEntity with default headers values
func NewPostCharactersAffiliationUnprocessableEntity() *PostCharactersAffiliationUnprocessableEntity {
	return &PostCharactersAffiliationUnprocessableEntity{}
}

/*PostCharactersAffiliationUnprocessableEntity handles this case with default header values.

No valid character IDs found
*/
type PostCharactersAffiliationUnprocessableEntity struct {
	Payload PostCharactersAffiliationUnprocessableEntityBody
}

func (o *PostCharactersAffiliationUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /characters/affiliation/][%d] postCharactersAffiliationUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostCharactersAffiliationUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCharactersAffiliationInternalServerError creates a PostCharactersAffiliationInternalServerError with default headers values
func NewPostCharactersAffiliationInternalServerError() *PostCharactersAffiliationInternalServerError {
	return &PostCharactersAffiliationInternalServerError{}
}

/*PostCharactersAffiliationInternalServerError handles this case with default header values.

Internal server error
*/
type PostCharactersAffiliationInternalServerError struct {
	Payload PostCharactersAffiliationInternalServerErrorBody
}

func (o *PostCharactersAffiliationInternalServerError) Error() string {
	return fmt.Sprintf("[POST /characters/affiliation/][%d] postCharactersAffiliationInternalServerError  %+v", 500, o.Payload)
}

func (o *PostCharactersAffiliationInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*PostCharactersAffiliationInternalServerErrorBody post_characters_affiliation_internal_server_error
//
// Internal server error
swagger:model PostCharactersAffiliationInternalServerErrorBody
*/
type PostCharactersAffiliationInternalServerErrorBody struct {

	// post_characters_affiliation_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post characters affiliation internal server error body
func (o *PostCharactersAffiliationInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersAffiliationInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postCharactersAffiliationInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersAffiliationInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersAffiliationInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersAffiliationInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCharactersAffiliationOKBodyItems0 post_characters_affiliation_200_ok
//
// 200 ok object
swagger:model PostCharactersAffiliationOKBodyItems0
*/
type PostCharactersAffiliationOKBodyItems0 struct {

	// post_characters_affiliation_alliance_id
	//
	// The character's alliance ID, if their corporation is in an alliance
	AllianceID int32 `json:"alliance_id,omitempty"`

	// post_characters_affiliation_character_id
	//
	// The character's ID
	// Required: true
	CharacterID *int32 `json:"character_id"`

	// post_characters_affiliation_corporation_id
	//
	// The character's corporation ID
	// Required: true
	CorporationID *int32 `json:"corporation_id"`

	// post_characters_affiliation_faction_id
	//
	// The character's faction ID, if their corporation is in a faction
	FactionID int32 `json:"faction_id,omitempty"`
}

// Validate validates this post characters affiliation o k body items0
func (o *PostCharactersAffiliationOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCharacterID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateCorporationID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersAffiliationOKBodyItems0) validateCharacterID(formats strfmt.Registry) error {

	if err := validate.Required("character_id", "body", o.CharacterID); err != nil {
		return err
	}

	return nil
}

func (o *PostCharactersAffiliationOKBodyItems0) validateCorporationID(formats strfmt.Registry) error {

	if err := validate.Required("corporation_id", "body", o.CorporationID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersAffiliationOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersAffiliationOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res PostCharactersAffiliationOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCharactersAffiliationUnprocessableEntityBody post_characters_affiliation_unprocessable_entity
//
// Unprocessable entity
swagger:model PostCharactersAffiliationUnprocessableEntityBody
*/
type PostCharactersAffiliationUnprocessableEntityBody struct {

	// post_characters_affiliation_422_unprocessable_entity
	//
	// Unprocessable entity message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post characters affiliation unprocessable entity body
func (o *PostCharactersAffiliationUnprocessableEntityBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersAffiliationUnprocessableEntityBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postCharactersAffiliationUnprocessableEntity"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersAffiliationUnprocessableEntityBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersAffiliationUnprocessableEntityBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersAffiliationUnprocessableEntityBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
