package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// PostCharactersCharacterIDCspaReader is a Reader for the PostCharactersCharacterIDCspa structure.
type PostCharactersCharacterIDCspaReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCharactersCharacterIDCspaReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 201:
		result := NewPostCharactersCharacterIDCspaCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewPostCharactersCharacterIDCspaForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewPostCharactersCharacterIDCspaInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostCharactersCharacterIDCspaCreated creates a PostCharactersCharacterIDCspaCreated with default headers values
func NewPostCharactersCharacterIDCspaCreated() *PostCharactersCharacterIDCspaCreated {
	return &PostCharactersCharacterIDCspaCreated{}
}

/*PostCharactersCharacterIDCspaCreated handles this case with default header values.

Aggregate cost of sending a mail from the source character to the target characters, in ISK hundredths
*/
type PostCharactersCharacterIDCspaCreated struct {
	Payload PostCharactersCharacterIDCspaCreatedBody
}

func (o *PostCharactersCharacterIDCspaCreated) Error() string {
	return fmt.Sprintf("[POST /characters/{character_id}/cspa/][%d] postCharactersCharacterIdCspaCreated  %+v", 201, o.Payload)
}

func (o *PostCharactersCharacterIDCspaCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCharactersCharacterIDCspaForbidden creates a PostCharactersCharacterIDCspaForbidden with default headers values
func NewPostCharactersCharacterIDCspaForbidden() *PostCharactersCharacterIDCspaForbidden {
	return &PostCharactersCharacterIDCspaForbidden{}
}

/*PostCharactersCharacterIDCspaForbidden handles this case with default header values.

Forbidden
*/
type PostCharactersCharacterIDCspaForbidden struct {
	Payload PostCharactersCharacterIDCspaForbiddenBody
}

func (o *PostCharactersCharacterIDCspaForbidden) Error() string {
	return fmt.Sprintf("[POST /characters/{character_id}/cspa/][%d] postCharactersCharacterIdCspaForbidden  %+v", 403, o.Payload)
}

func (o *PostCharactersCharacterIDCspaForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCharactersCharacterIDCspaInternalServerError creates a PostCharactersCharacterIDCspaInternalServerError with default headers values
func NewPostCharactersCharacterIDCspaInternalServerError() *PostCharactersCharacterIDCspaInternalServerError {
	return &PostCharactersCharacterIDCspaInternalServerError{}
}

/*PostCharactersCharacterIDCspaInternalServerError handles this case with default header values.

Internal server error
*/
type PostCharactersCharacterIDCspaInternalServerError struct {
	Payload PostCharactersCharacterIDCspaInternalServerErrorBody
}

func (o *PostCharactersCharacterIDCspaInternalServerError) Error() string {
	return fmt.Sprintf("[POST /characters/{character_id}/cspa/][%d] postCharactersCharacterIdCspaInternalServerError  %+v", 500, o.Payload)
}

func (o *PostCharactersCharacterIDCspaInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*PostCharactersCharacterIDCspaBody post_characters_character_id_cspa_characters
//
// characters object
swagger:model PostCharactersCharacterIDCspaBody
*/
type PostCharactersCharacterIDCspaBody struct {

	// post_characters_character_id_cspa_characters
	//
	// characters array
	// Required: true
	// Max Items: 100
	// Min Items: 1
	// Unique: true
	Characters []int32 `json:"characters"`
}

// MarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersCharacterIDCspaBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCharactersCharacterIDCspaCreatedBody post_characters_character_id_cspa_created
//
// 201 created object
swagger:model PostCharactersCharacterIDCspaCreatedBody
*/
type PostCharactersCharacterIDCspaCreatedBody struct {

	// post_characters_character_id_cspa_cost
	//
	// cost integer
	// Required: true
	Cost *int64 `json:"cost"`
}

// Validate validates this post characters character ID cspa created body
func (o *PostCharactersCharacterIDCspaCreatedBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCost(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersCharacterIDCspaCreatedBody) validateCost(formats strfmt.Registry) error {

	if err := validate.Required("postCharactersCharacterIdCspaCreated"+"."+"cost", "body", o.Cost); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaCreatedBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaCreatedBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersCharacterIDCspaCreatedBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCharactersCharacterIDCspaForbiddenBody post_characters_character_id_cspa_forbidden
//
// Forbidden
swagger:model PostCharactersCharacterIDCspaForbiddenBody
*/
type PostCharactersCharacterIDCspaForbiddenBody struct {

	// post_characters_character_id_cspa_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post characters character ID cspa forbidden body
func (o *PostCharactersCharacterIDCspaForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersCharacterIDCspaForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postCharactersCharacterIdCspaForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaForbiddenBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersCharacterIDCspaForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostCharactersCharacterIDCspaInternalServerErrorBody post_characters_character_id_cspa_internal_server_error
//
// Internal server error
swagger:model PostCharactersCharacterIDCspaInternalServerErrorBody
*/
type PostCharactersCharacterIDCspaInternalServerErrorBody struct {

	// post_characters_character_id_cspa_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post characters character ID cspa internal server error body
func (o *PostCharactersCharacterIDCspaInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostCharactersCharacterIDCspaInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postCharactersCharacterIdCspaInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostCharactersCharacterIDCspaInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res PostCharactersCharacterIDCspaInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
