package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDContactsLabelsReader is a Reader for the GetCharactersCharacterIDContactsLabels structure.
type GetCharactersCharacterIDContactsLabelsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDContactsLabelsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDContactsLabelsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDContactsLabelsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDContactsLabelsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDContactsLabelsOK creates a GetCharactersCharacterIDContactsLabelsOK with default headers values
func NewGetCharactersCharacterIDContactsLabelsOK() *GetCharactersCharacterIDContactsLabelsOK {
	return &GetCharactersCharacterIDContactsLabelsOK{}
}

/*GetCharactersCharacterIDContactsLabelsOK handles this case with default header values.

A list of contact labels
*/
type GetCharactersCharacterIDContactsLabelsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDContactsLabelsOKBodyItems0
}

func (o *GetCharactersCharacterIDContactsLabelsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/labels/][%d] getCharactersCharacterIdContactsLabelsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDContactsLabelsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsLabelsForbidden creates a GetCharactersCharacterIDContactsLabelsForbidden with default headers values
func NewGetCharactersCharacterIDContactsLabelsForbidden() *GetCharactersCharacterIDContactsLabelsForbidden {
	return &GetCharactersCharacterIDContactsLabelsForbidden{}
}

/*GetCharactersCharacterIDContactsLabelsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDContactsLabelsForbidden struct {
	Payload GetCharactersCharacterIDContactsLabelsForbiddenBody
}

func (o *GetCharactersCharacterIDContactsLabelsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/labels/][%d] getCharactersCharacterIdContactsLabelsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDContactsLabelsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsLabelsInternalServerError creates a GetCharactersCharacterIDContactsLabelsInternalServerError with default headers values
func NewGetCharactersCharacterIDContactsLabelsInternalServerError() *GetCharactersCharacterIDContactsLabelsInternalServerError {
	return &GetCharactersCharacterIDContactsLabelsInternalServerError{}
}

/*GetCharactersCharacterIDContactsLabelsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDContactsLabelsInternalServerError struct {
	Payload GetCharactersCharacterIDContactsLabelsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDContactsLabelsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/labels/][%d] getCharactersCharacterIdContactsLabelsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDContactsLabelsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDContactsLabelsForbiddenBody get_characters_character_id_contacts_labels_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDContactsLabelsForbiddenBody
*/
type GetCharactersCharacterIDContactsLabelsForbiddenBody struct {

	// get_characters_character_id_contacts_labels_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contacts labels forbidden body
func (o *GetCharactersCharacterIDContactsLabelsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsLabelsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContactsLabelsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsLabelsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContactsLabelsInternalServerErrorBody get_characters_character_id_contacts_labels_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDContactsLabelsInternalServerErrorBody
*/
type GetCharactersCharacterIDContactsLabelsInternalServerErrorBody struct {

	// get_characters_character_id_contacts_labels_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contacts labels internal server error body
func (o *GetCharactersCharacterIDContactsLabelsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsLabelsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContactsLabelsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsLabelsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContactsLabelsOKBodyItems0 get_characters_character_id_contacts_labels_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDContactsLabelsOKBodyItems0
*/
type GetCharactersCharacterIDContactsLabelsOKBodyItems0 struct {

	// get_characters_character_id_contacts_labels_label_id
	//
	// label_id integer
	// Required: true
	LabelID *int64 `json:"label_id"`

	// get_characters_character_id_contacts_labels_label_name
	//
	// label_name string
	// Required: true
	LabelName *string `json:"label_name"`
}

// Validate validates this get characters character ID contacts labels o k body items0
func (o *GetCharactersCharacterIDContactsLabelsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateLabelID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLabelName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsLabelsOKBodyItems0) validateLabelID(formats strfmt.Registry) error {

	if err := validate.Required("label_id", "body", o.LabelID); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDContactsLabelsOKBodyItems0) validateLabelName(formats strfmt.Registry) error {

	if err := validate.Required("label_name", "body", o.LabelName); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsLabelsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsLabelsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
