package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDContactsReader is a Reader for the GetCharactersCharacterIDContacts structure.
type GetCharactersCharacterIDContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDContactsOK creates a GetCharactersCharacterIDContactsOK with default headers values
func NewGetCharactersCharacterIDContactsOK() *GetCharactersCharacterIDContactsOK {
	return &GetCharactersCharacterIDContactsOK{}
}

/*GetCharactersCharacterIDContactsOK handles this case with default header values.

A list of contacts
*/
type GetCharactersCharacterIDContactsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDContactsOKBodyItems0
}

func (o *GetCharactersCharacterIDContactsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsForbidden creates a GetCharactersCharacterIDContactsForbidden with default headers values
func NewGetCharactersCharacterIDContactsForbidden() *GetCharactersCharacterIDContactsForbidden {
	return &GetCharactersCharacterIDContactsForbidden{}
}

/*GetCharactersCharacterIDContactsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDContactsForbidden struct {
	Payload GetCharactersCharacterIDContactsForbiddenBody
}

func (o *GetCharactersCharacterIDContactsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContactsInternalServerError creates a GetCharactersCharacterIDContactsInternalServerError with default headers values
func NewGetCharactersCharacterIDContactsInternalServerError() *GetCharactersCharacterIDContactsInternalServerError {
	return &GetCharactersCharacterIDContactsInternalServerError{}
}

/*GetCharactersCharacterIDContactsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDContactsInternalServerError struct {
	Payload GetCharactersCharacterIDContactsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDContactsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contacts/][%d] getCharactersCharacterIdContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDContactsForbiddenBody get_characters_character_id_contacts_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDContactsForbiddenBody
*/
type GetCharactersCharacterIDContactsForbiddenBody struct {

	// get_characters_character_id_contacts_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contacts forbidden body
func (o *GetCharactersCharacterIDContactsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContactsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContactsInternalServerErrorBody get_characters_character_id_contacts_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDContactsInternalServerErrorBody
*/
type GetCharactersCharacterIDContactsInternalServerErrorBody struct {

	// get_characters_character_id_contacts_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contacts internal server error body
func (o *GetCharactersCharacterIDContactsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContactsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContactsOKBodyItems0 get_characters_character_id_contacts_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDContactsOKBodyItems0
*/
type GetCharactersCharacterIDContactsOKBodyItems0 struct {

	// get_characters_character_id_contacts_contact_id
	//
	// contact_id integer
	// Required: true
	ContactID *int32 `json:"contact_id"`

	// get_characters_character_id_contacts_contact_type
	//
	// contact_type string
	// Required: true
	ContactType *string `json:"contact_type"`

	// get_characters_character_id_contacts_is_blocked
	//
	// Whether this contact is in the blocked list. Note a missing value denotes unknown, not true or false
	IsBlocked bool `json:"is_blocked,omitempty"`

	// get_characters_character_id_contacts_is_watched
	//
	// Whether this contact is being watched
	IsWatched bool `json:"is_watched,omitempty"`

	// get_characters_character_id_contacts_label_id
	//
	// Custom label of the contact
	LabelID int64 `json:"label_id,omitempty"`

	// get_characters_character_id_contacts_standing
	//
	// Standing of the contact
	// Required: true
	Standing *float32 `json:"standing"`
}

// Validate validates this get characters character ID contacts o k body items0
func (o *GetCharactersCharacterIDContactsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateContactID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateContactType(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateStanding(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsOKBodyItems0) validateContactID(formats strfmt.Registry) error {

	if err := validate.Required("contact_id", "body", o.ContactID); err != nil {
		return err
	}

	return nil
}

var getCharactersCharacterIdContactsOKBodyItems0TypeContactTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["character","corporation","alliance","faction"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		getCharactersCharacterIdContactsOKBodyItems0TypeContactTypePropEnum = append(getCharactersCharacterIdContactsOKBodyItems0TypeContactTypePropEnum, v)
	}
}

const (
	// GetCharactersCharacterIDContactsOKBodyItems0ContactTypeCharacter captures enum value "character"
	GetCharactersCharacterIDContactsOKBodyItems0ContactTypeCharacter string = "character"
	// GetCharactersCharacterIDContactsOKBodyItems0ContactTypeCorporation captures enum value "corporation"
	GetCharactersCharacterIDContactsOKBodyItems0ContactTypeCorporation string = "corporation"
	// GetCharactersCharacterIDContactsOKBodyItems0ContactTypeAlliance captures enum value "alliance"
	GetCharactersCharacterIDContactsOKBodyItems0ContactTypeAlliance string = "alliance"
	// GetCharactersCharacterIDContactsOKBodyItems0ContactTypeFaction captures enum value "faction"
	GetCharactersCharacterIDContactsOKBodyItems0ContactTypeFaction string = "faction"
)

// prop value enum
func (o *GetCharactersCharacterIDContactsOKBodyItems0) validateContactTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, getCharactersCharacterIdContactsOKBodyItems0TypeContactTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (o *GetCharactersCharacterIDContactsOKBodyItems0) validateContactType(formats strfmt.Registry) error {

	if err := validate.Required("contact_type", "body", o.ContactType); err != nil {
		return err
	}

	// value enum
	if err := o.validateContactTypeEnum("contact_type", "body", *o.ContactType); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDContactsOKBodyItems0) validateStanding(formats strfmt.Registry) error {

	if err := validate.Required("standing", "body", o.Standing); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContactsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContactsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
