package contracts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDContractsContractIDBidsReader is a Reader for the GetCharactersCharacterIDContractsContractIDBids structure.
type GetCharactersCharacterIDContractsContractIDBidsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDContractsContractIDBidsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDContractsContractIDBidsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDContractsContractIDBidsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDContractsContractIDBidsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDContractsContractIDBidsOK creates a GetCharactersCharacterIDContractsContractIDBidsOK with default headers values
func NewGetCharactersCharacterIDContractsContractIDBidsOK() *GetCharactersCharacterIDContractsContractIDBidsOK {
	return &GetCharactersCharacterIDContractsContractIDBidsOK{}
}

/*GetCharactersCharacterIDContractsContractIDBidsOK handles this case with default header values.

A list of contracts
*/
type GetCharactersCharacterIDContractsContractIDBidsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contracts/{contract_id}/bids/][%d] getCharactersCharacterIdContractsContractIdBidsOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContractsContractIDBidsForbidden creates a GetCharactersCharacterIDContractsContractIDBidsForbidden with default headers values
func NewGetCharactersCharacterIDContractsContractIDBidsForbidden() *GetCharactersCharacterIDContractsContractIDBidsForbidden {
	return &GetCharactersCharacterIDContractsContractIDBidsForbidden{}
}

/*GetCharactersCharacterIDContractsContractIDBidsForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDContractsContractIDBidsForbidden struct {
	Payload GetCharactersCharacterIDContractsContractIDBidsForbiddenBody
}

func (o *GetCharactersCharacterIDContractsContractIDBidsForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contracts/{contract_id}/bids/][%d] getCharactersCharacterIdContractsContractIdBidsForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDContractsContractIDBidsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDContractsContractIDBidsInternalServerError creates a GetCharactersCharacterIDContractsContractIDBidsInternalServerError with default headers values
func NewGetCharactersCharacterIDContractsContractIDBidsInternalServerError() *GetCharactersCharacterIDContractsContractIDBidsInternalServerError {
	return &GetCharactersCharacterIDContractsContractIDBidsInternalServerError{}
}

/*GetCharactersCharacterIDContractsContractIDBidsInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDContractsContractIDBidsInternalServerError struct {
	Payload GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody
}

func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/contracts/{contract_id}/bids/][%d] getCharactersCharacterIdContractsContractIdBidsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDContractsContractIDBidsForbiddenBody get_characters_character_id_contracts_contract_id_bids_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDContractsContractIDBidsForbiddenBody
*/
type GetCharactersCharacterIDContractsContractIDBidsForbiddenBody struct {

	// get_characters_character_id_contracts_contract_id_bids_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contracts contract ID bids forbidden body
func (o *GetCharactersCharacterIDContractsContractIDBidsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContractsContractIdBidsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContractsContractIDBidsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody get_characters_character_id_contracts_contract_id_bids_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody
*/
type GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody struct {

	// get_characters_character_id_contracts_contract_id_bids_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID contracts contract ID bids internal server error body
func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdContractsContractIdBidsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContractsContractIDBidsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0 get_characters_character_id_contracts_contract_id_bids_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0
*/
type GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0 struct {

	// get_characters_character_id_contracts_contract_id_bids_amount
	//
	// The ammount bid
	// Required: true
	Amount *float32 `json:"amount"`

	// get_characters_character_id_contracts_contract_id_bids_bid_id
	//
	// Unique ID for the bid
	// Required: true
	BidID *int32 `json:"bid_id"`

	// get_characters_character_id_contracts_contract_id_bids_bidder_id
	//
	// Character ID of the bidder
	// Required: true
	BidderID *int32 `json:"bidder_id"`

	// get_characters_character_id_contracts_contract_id_bids_date_bid
	//
	// Datetime when the bid was placed
	// Required: true
	DateBid *strfmt.DateTime `json:"date_bid"`
}

// Validate validates this get characters character ID contracts contract ID bids o k body items0
func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateAmount(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateBidID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateBidderID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateDateBid(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) validateAmount(formats strfmt.Registry) error {

	if err := validate.Required("amount", "body", o.Amount); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) validateBidID(formats strfmt.Registry) error {

	if err := validate.Required("bid_id", "body", o.BidID); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) validateBidderID(formats strfmt.Registry) error {

	if err := validate.Required("bidder_id", "body", o.BidderID); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) validateDateBid(formats strfmt.Registry) error {

	if err := validate.Required("date_bid", "body", o.DateBid); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDContractsContractIDBidsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
