package corporation

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCorporationsCorporationIDMembersReader is a Reader for the GetCorporationsCorporationIDMembers structure.
type GetCorporationsCorporationIDMembersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCorporationsCorporationIDMembersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCorporationsCorporationIDMembersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCorporationsCorporationIDMembersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCorporationsCorporationIDMembersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCorporationsCorporationIDMembersOK creates a GetCorporationsCorporationIDMembersOK with default headers values
func NewGetCorporationsCorporationIDMembersOK() *GetCorporationsCorporationIDMembersOK {
	return &GetCorporationsCorporationIDMembersOK{}
}

/*GetCorporationsCorporationIDMembersOK handles this case with default header values.

List of member character IDs
*/
type GetCorporationsCorporationIDMembersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCorporationsCorporationIDMembersOKBodyItems0
}

func (o *GetCorporationsCorporationIDMembersOK) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersOK  %+v", 200, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDMembersForbidden creates a GetCorporationsCorporationIDMembersForbidden with default headers values
func NewGetCorporationsCorporationIDMembersForbidden() *GetCorporationsCorporationIDMembersForbidden {
	return &GetCorporationsCorporationIDMembersForbidden{}
}

/*GetCorporationsCorporationIDMembersForbidden handles this case with default header values.

Forbidden
*/
type GetCorporationsCorporationIDMembersForbidden struct {
	Payload GetCorporationsCorporationIDMembersForbiddenBody
}

func (o *GetCorporationsCorporationIDMembersForbidden) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersForbidden  %+v", 403, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCorporationsCorporationIDMembersInternalServerError creates a GetCorporationsCorporationIDMembersInternalServerError with default headers values
func NewGetCorporationsCorporationIDMembersInternalServerError() *GetCorporationsCorporationIDMembersInternalServerError {
	return &GetCorporationsCorporationIDMembersInternalServerError{}
}

/*GetCorporationsCorporationIDMembersInternalServerError handles this case with default header values.

Internal server error
*/
type GetCorporationsCorporationIDMembersInternalServerError struct {
	Payload GetCorporationsCorporationIDMembersInternalServerErrorBody
}

func (o *GetCorporationsCorporationIDMembersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /corporations/{corporation_id}/members/][%d] getCorporationsCorporationIdMembersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCorporationsCorporationIDMembersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCorporationsCorporationIDMembersForbiddenBody get_corporations_corporation_id_members_forbidden
//
// Forbidden
swagger:model GetCorporationsCorporationIDMembersForbiddenBody
*/
type GetCorporationsCorporationIDMembersForbiddenBody struct {

	// get_corporations_corporation_id_members_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get corporations corporation ID members forbidden body
func (o *GetCorporationsCorporationIDMembersForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCorporationsCorporationIDMembersForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCorporationsCorporationIdMembersForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCorporationsCorporationIDMembersForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCorporationsCorporationIDMembersInternalServerErrorBody get_corporations_corporation_id_members_internal_server_error
//
// Internal server error
swagger:model GetCorporationsCorporationIDMembersInternalServerErrorBody
*/
type GetCorporationsCorporationIDMembersInternalServerErrorBody struct {

	// get_corporations_corporation_id_members_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get corporations corporation ID members internal server error body
func (o *GetCorporationsCorporationIDMembersInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCorporationsCorporationIDMembersInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCorporationsCorporationIdMembersInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCorporationsCorporationIDMembersInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCorporationsCorporationIDMembersOKBodyItems0 get_corporations_corporation_id_members_200_ok
//
// 200 ok object
swagger:model GetCorporationsCorporationIDMembersOKBodyItems0
*/
type GetCorporationsCorporationIDMembersOKBodyItems0 struct {

	// get_corporations_corporation_id_members_character_id
	//
	// character_id integer
	// Required: true
	CharacterID *int32 `json:"character_id"`
}

// Validate validates this get corporations corporation ID members o k body items0
func (o *GetCorporationsCorporationIDMembersOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCharacterID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCorporationsCorporationIDMembersOKBodyItems0) validateCharacterID(formats strfmt.Registry) error {

	if err := validate.Required("character_id", "body", o.CharacterID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCorporationsCorporationIDMembersOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCorporationsCorporationIDMembersOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
