package fittings

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// DeleteCharactersCharacterIDFittingsFittingIDReader is a Reader for the DeleteCharactersCharacterIDFittingsFittingID structure.
type DeleteCharactersCharacterIDFittingsFittingIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteCharactersCharacterIDFittingsFittingIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 204:
		result := NewDeleteCharactersCharacterIDFittingsFittingIDNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewDeleteCharactersCharacterIDFittingsFittingIDForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewDeleteCharactersCharacterIDFittingsFittingIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteCharactersCharacterIDFittingsFittingIDNoContent creates a DeleteCharactersCharacterIDFittingsFittingIDNoContent with default headers values
func NewDeleteCharactersCharacterIDFittingsFittingIDNoContent() *DeleteCharactersCharacterIDFittingsFittingIDNoContent {
	return &DeleteCharactersCharacterIDFittingsFittingIDNoContent{}
}

/*DeleteCharactersCharacterIDFittingsFittingIDNoContent handles this case with default header values.

Fitting deleted
*/
type DeleteCharactersCharacterIDFittingsFittingIDNoContent struct {
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDNoContent) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/fittings/{fitting_id}/][%d] deleteCharactersCharacterIdFittingsFittingIdNoContent ", 204)
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteCharactersCharacterIDFittingsFittingIDForbidden creates a DeleteCharactersCharacterIDFittingsFittingIDForbidden with default headers values
func NewDeleteCharactersCharacterIDFittingsFittingIDForbidden() *DeleteCharactersCharacterIDFittingsFittingIDForbidden {
	return &DeleteCharactersCharacterIDFittingsFittingIDForbidden{}
}

/*DeleteCharactersCharacterIDFittingsFittingIDForbidden handles this case with default header values.

Forbidden
*/
type DeleteCharactersCharacterIDFittingsFittingIDForbidden struct {
	Payload DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDForbidden) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/fittings/{fitting_id}/][%d] deleteCharactersCharacterIdFittingsFittingIdForbidden  %+v", 403, o.Payload)
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteCharactersCharacterIDFittingsFittingIDInternalServerError creates a DeleteCharactersCharacterIDFittingsFittingIDInternalServerError with default headers values
func NewDeleteCharactersCharacterIDFittingsFittingIDInternalServerError() *DeleteCharactersCharacterIDFittingsFittingIDInternalServerError {
	return &DeleteCharactersCharacterIDFittingsFittingIDInternalServerError{}
}

/*DeleteCharactersCharacterIDFittingsFittingIDInternalServerError handles this case with default header values.

Internal server error
*/
type DeleteCharactersCharacterIDFittingsFittingIDInternalServerError struct {
	Payload DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /characters/{character_id}/fittings/{fitting_id}/][%d] deleteCharactersCharacterIdFittingsFittingIdInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody delete_characters_character_id_fittings_fitting_id_forbidden
//
// Forbidden
swagger:model DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody
*/
type DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody struct {

	// delete_characters_character_id_fittings_fitting_id_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this delete characters character ID fittings fitting ID forbidden body
func (o *DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("deleteCharactersCharacterIdFittingsFittingIdForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody) UnmarshalBinary(b []byte) error {
	var res DeleteCharactersCharacterIDFittingsFittingIDForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody delete_characters_character_id_fittings_fitting_id_internal_server_error
//
// Internal server error
swagger:model DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody
*/
type DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody struct {

	// delete_characters_character_id_fittings_fitting_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this delete characters character ID fittings fitting ID internal server error body
func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("deleteCharactersCharacterIdFittingsFittingIdInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res DeleteCharactersCharacterIDFittingsFittingIDInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
