package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// DeleteFleetsFleetIDSquadsSquadIDReader is a Reader for the DeleteFleetsFleetIDSquadsSquadID structure.
type DeleteFleetsFleetIDSquadsSquadIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteFleetsFleetIDSquadsSquadIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 204:
		result := NewDeleteFleetsFleetIDSquadsSquadIDNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewDeleteFleetsFleetIDSquadsSquadIDForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewDeleteFleetsFleetIDSquadsSquadIDNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewDeleteFleetsFleetIDSquadsSquadIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeleteFleetsFleetIDSquadsSquadIDNoContent creates a DeleteFleetsFleetIDSquadsSquadIDNoContent with default headers values
func NewDeleteFleetsFleetIDSquadsSquadIDNoContent() *DeleteFleetsFleetIDSquadsSquadIDNoContent {
	return &DeleteFleetsFleetIDSquadsSquadIDNoContent{}
}

/*DeleteFleetsFleetIDSquadsSquadIDNoContent handles this case with default header values.

Squad deleted
*/
type DeleteFleetsFleetIDSquadsSquadIDNoContent struct {
}

func (o *DeleteFleetsFleetIDSquadsSquadIDNoContent) Error() string {
	return fmt.Sprintf("[DELETE /fleets/{fleet_id}/squads/{squad_id}/][%d] deleteFleetsFleetIdSquadsSquadIdNoContent ", 204)
}

func (o *DeleteFleetsFleetIDSquadsSquadIDNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewDeleteFleetsFleetIDSquadsSquadIDForbidden creates a DeleteFleetsFleetIDSquadsSquadIDForbidden with default headers values
func NewDeleteFleetsFleetIDSquadsSquadIDForbidden() *DeleteFleetsFleetIDSquadsSquadIDForbidden {
	return &DeleteFleetsFleetIDSquadsSquadIDForbidden{}
}

/*DeleteFleetsFleetIDSquadsSquadIDForbidden handles this case with default header values.

Forbidden
*/
type DeleteFleetsFleetIDSquadsSquadIDForbidden struct {
	Payload DeleteFleetsFleetIDSquadsSquadIDForbiddenBody
}

func (o *DeleteFleetsFleetIDSquadsSquadIDForbidden) Error() string {
	return fmt.Sprintf("[DELETE /fleets/{fleet_id}/squads/{squad_id}/][%d] deleteFleetsFleetIdSquadsSquadIdForbidden  %+v", 403, o.Payload)
}

func (o *DeleteFleetsFleetIDSquadsSquadIDForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteFleetsFleetIDSquadsSquadIDNotFound creates a DeleteFleetsFleetIDSquadsSquadIDNotFound with default headers values
func NewDeleteFleetsFleetIDSquadsSquadIDNotFound() *DeleteFleetsFleetIDSquadsSquadIDNotFound {
	return &DeleteFleetsFleetIDSquadsSquadIDNotFound{}
}

/*DeleteFleetsFleetIDSquadsSquadIDNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type DeleteFleetsFleetIDSquadsSquadIDNotFound struct {
	Payload DeleteFleetsFleetIDSquadsSquadIDNotFoundBody
}

func (o *DeleteFleetsFleetIDSquadsSquadIDNotFound) Error() string {
	return fmt.Sprintf("[DELETE /fleets/{fleet_id}/squads/{squad_id}/][%d] deleteFleetsFleetIdSquadsSquadIdNotFound  %+v", 404, o.Payload)
}

func (o *DeleteFleetsFleetIDSquadsSquadIDNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteFleetsFleetIDSquadsSquadIDInternalServerError creates a DeleteFleetsFleetIDSquadsSquadIDInternalServerError with default headers values
func NewDeleteFleetsFleetIDSquadsSquadIDInternalServerError() *DeleteFleetsFleetIDSquadsSquadIDInternalServerError {
	return &DeleteFleetsFleetIDSquadsSquadIDInternalServerError{}
}

/*DeleteFleetsFleetIDSquadsSquadIDInternalServerError handles this case with default header values.

Internal server error
*/
type DeleteFleetsFleetIDSquadsSquadIDInternalServerError struct {
	Payload DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody
}

func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /fleets/{fleet_id}/squads/{squad_id}/][%d] deleteFleetsFleetIdSquadsSquadIdInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*DeleteFleetsFleetIDSquadsSquadIDForbiddenBody delete_fleets_fleet_id_squads_squad_id_forbidden
//
// Forbidden
swagger:model DeleteFleetsFleetIDSquadsSquadIDForbiddenBody
*/
type DeleteFleetsFleetIDSquadsSquadIDForbiddenBody struct {

	// delete_fleets_fleet_id_squads_squad_id_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this delete fleets fleet ID squads squad ID forbidden body
func (o *DeleteFleetsFleetIDSquadsSquadIDForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteFleetsFleetIDSquadsSquadIDForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("deleteFleetsFleetIdSquadsSquadIdForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDForbiddenBody) UnmarshalBinary(b []byte) error {
	var res DeleteFleetsFleetIDSquadsSquadIDForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody delete_fleets_fleet_id_squads_squad_id_internal_server_error
//
// Internal server error
swagger:model DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody
*/
type DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody struct {

	// delete_fleets_fleet_id_squads_squad_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this delete fleets fleet ID squads squad ID internal server error body
func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("deleteFleetsFleetIdSquadsSquadIdInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res DeleteFleetsFleetIDSquadsSquadIDInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*DeleteFleetsFleetIDSquadsSquadIDNotFoundBody delete_fleets_fleet_id_squads_squad_id_not_found
//
// Not found
swagger:model DeleteFleetsFleetIDSquadsSquadIDNotFoundBody
*/
type DeleteFleetsFleetIDSquadsSquadIDNotFoundBody struct {

	// delete_fleets_fleet_id_squads_squad_id_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this delete fleets fleet ID squads squad ID not found body
func (o *DeleteFleetsFleetIDSquadsSquadIDNotFoundBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *DeleteFleetsFleetIDSquadsSquadIDNotFoundBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("deleteFleetsFleetIdSquadsSquadIdNotFound"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDNotFoundBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *DeleteFleetsFleetIDSquadsSquadIDNotFoundBody) UnmarshalBinary(b []byte) error {
	var res DeleteFleetsFleetIDSquadsSquadIDNotFoundBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
