package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetFleetsFleetIDMembersReader is a Reader for the GetFleetsFleetIDMembers structure.
type GetFleetsFleetIDMembersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFleetsFleetIDMembersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFleetsFleetIDMembersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetFleetsFleetIDMembersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetFleetsFleetIDMembersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetFleetsFleetIDMembersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFleetsFleetIDMembersOK creates a GetFleetsFleetIDMembersOK with default headers values
func NewGetFleetsFleetIDMembersOK() *GetFleetsFleetIDMembersOK {
	return &GetFleetsFleetIDMembersOK{}
}

/*GetFleetsFleetIDMembersOK handles this case with default header values.

A list of fleet members
*/
type GetFleetsFleetIDMembersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetFleetsFleetIDMembersOKBodyItems0
}

func (o *GetFleetsFleetIDMembersOK) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersOK  %+v", 200, o.Payload)
}

func (o *GetFleetsFleetIDMembersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersForbidden creates a GetFleetsFleetIDMembersForbidden with default headers values
func NewGetFleetsFleetIDMembersForbidden() *GetFleetsFleetIDMembersForbidden {
	return &GetFleetsFleetIDMembersForbidden{}
}

/*GetFleetsFleetIDMembersForbidden handles this case with default header values.

Forbidden
*/
type GetFleetsFleetIDMembersForbidden struct {
	Payload GetFleetsFleetIDMembersForbiddenBody
}

func (o *GetFleetsFleetIDMembersForbidden) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersForbidden  %+v", 403, o.Payload)
}

func (o *GetFleetsFleetIDMembersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersNotFound creates a GetFleetsFleetIDMembersNotFound with default headers values
func NewGetFleetsFleetIDMembersNotFound() *GetFleetsFleetIDMembersNotFound {
	return &GetFleetsFleetIDMembersNotFound{}
}

/*GetFleetsFleetIDMembersNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type GetFleetsFleetIDMembersNotFound struct {
	Payload GetFleetsFleetIDMembersNotFoundBody
}

func (o *GetFleetsFleetIDMembersNotFound) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersNotFound  %+v", 404, o.Payload)
}

func (o *GetFleetsFleetIDMembersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersInternalServerError creates a GetFleetsFleetIDMembersInternalServerError with default headers values
func NewGetFleetsFleetIDMembersInternalServerError() *GetFleetsFleetIDMembersInternalServerError {
	return &GetFleetsFleetIDMembersInternalServerError{}
}

/*GetFleetsFleetIDMembersInternalServerError handles this case with default header values.

Internal server error
*/
type GetFleetsFleetIDMembersInternalServerError struct {
	Payload GetFleetsFleetIDMembersInternalServerErrorBody
}

func (o *GetFleetsFleetIDMembersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFleetsFleetIDMembersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetFleetsFleetIDMembersForbiddenBody get_fleets_fleet_id_members_forbidden
//
// Forbidden
swagger:model GetFleetsFleetIDMembersForbiddenBody
*/
type GetFleetsFleetIDMembersForbiddenBody struct {

	// get_fleets_fleet_id_members_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID members forbidden body
func (o *GetFleetsFleetIDMembersForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDMembersForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdMembersForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDMembersForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDMembersInternalServerErrorBody get_fleets_fleet_id_members_internal_server_error
//
// Internal server error
swagger:model GetFleetsFleetIDMembersInternalServerErrorBody
*/
type GetFleetsFleetIDMembersInternalServerErrorBody struct {

	// get_fleets_fleet_id_members_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID members internal server error body
func (o *GetFleetsFleetIDMembersInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDMembersInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdMembersInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDMembersInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDMembersNotFoundBody get_fleets_fleet_id_members_not_found
//
// Not found
swagger:model GetFleetsFleetIDMembersNotFoundBody
*/
type GetFleetsFleetIDMembersNotFoundBody struct {

	// get_fleets_fleet_id_members_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID members not found body
func (o *GetFleetsFleetIDMembersNotFoundBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDMembersNotFoundBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdMembersNotFound"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersNotFoundBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersNotFoundBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDMembersNotFoundBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDMembersOKBodyItems0 get_fleets_fleet_id_members_200_ok
//
// 200 ok object
swagger:model GetFleetsFleetIDMembersOKBodyItems0
*/
type GetFleetsFleetIDMembersOKBodyItems0 struct {

	// get_fleets_fleet_id_members_character_id
	//
	// character_id integer
	// Required: true
	CharacterID *int32 `json:"character_id"`

	// get_fleets_fleet_id_members_join_time
	//
	// join_time string
	// Required: true
	JoinTime *strfmt.DateTime `json:"join_time"`

	// get_fleets_fleet_id_members_role
	//
	// Member’s role in fleet
	// Required: true
	Role *string `json:"role"`

	// get_fleets_fleet_id_members_role_name
	//
	// Localized role names
	// Required: true
	RoleName *string `json:"role_name"`

	// get_fleets_fleet_id_members_ship_type_id
	//
	// ship_type_id integer
	// Required: true
	ShipTypeID *int32 `json:"ship_type_id"`

	// get_fleets_fleet_id_members_solar_system_id
	//
	// Solar system the member is located in
	// Required: true
	SolarSystemID *int32 `json:"solar_system_id"`

	// get_fleets_fleet_id_members_squad_id
	//
	// ID of the squad the member is in. If not applicable, will be set to -1
	// Required: true
	SquadID *int64 `json:"squad_id"`

	// get_fleets_fleet_id_members_station_id
	//
	// Station in which the member is docked in, if applicable
	StationID int64 `json:"station_id,omitempty"`

	// get_fleets_fleet_id_members_takes_fleet_warp
	//
	// Whether the member take fleet warps
	// Required: true
	TakesFleetWarp *bool `json:"takes_fleet_warp"`

	// get_fleets_fleet_id_members_wing_id
	//
	// ID of the wing the member is in. If not applicable, will be set to -1
	// Required: true
	WingID *int64 `json:"wing_id"`
}

// Validate validates this get fleets fleet ID members o k body items0
func (o *GetFleetsFleetIDMembersOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCharacterID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateJoinTime(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRole(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRoleName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateShipTypeID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateSolarSystemID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateSquadID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTakesFleetWarp(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateWingID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateCharacterID(formats strfmt.Registry) error {

	if err := validate.Required("character_id", "body", o.CharacterID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateJoinTime(formats strfmt.Registry) error {

	if err := validate.Required("join_time", "body", o.JoinTime); err != nil {
		return err
	}

	return nil
}

var getFleetsFleetIdMembersOKBodyItems0TypeRolePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fleet_commander","wing_commander","squad_commander","squad_member"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		getFleetsFleetIdMembersOKBodyItems0TypeRolePropEnum = append(getFleetsFleetIdMembersOKBodyItems0TypeRolePropEnum, v)
	}
}

const (
	// GetFleetsFleetIDMembersOKBodyItems0RoleFleetCommander captures enum value "fleet_commander"
	GetFleetsFleetIDMembersOKBodyItems0RoleFleetCommander string = "fleet_commander"
	// GetFleetsFleetIDMembersOKBodyItems0RoleWingCommander captures enum value "wing_commander"
	GetFleetsFleetIDMembersOKBodyItems0RoleWingCommander string = "wing_commander"
	// GetFleetsFleetIDMembersOKBodyItems0RoleSquadCommander captures enum value "squad_commander"
	GetFleetsFleetIDMembersOKBodyItems0RoleSquadCommander string = "squad_commander"
	// GetFleetsFleetIDMembersOKBodyItems0RoleSquadMember captures enum value "squad_member"
	GetFleetsFleetIDMembersOKBodyItems0RoleSquadMember string = "squad_member"
)

// prop value enum
func (o *GetFleetsFleetIDMembersOKBodyItems0) validateRoleEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, getFleetsFleetIdMembersOKBodyItems0TypeRolePropEnum); err != nil {
		return err
	}
	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateRole(formats strfmt.Registry) error {

	if err := validate.Required("role", "body", o.Role); err != nil {
		return err
	}

	// value enum
	if err := o.validateRoleEnum("role", "body", *o.Role); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateRoleName(formats strfmt.Registry) error {

	if err := validate.Required("role_name", "body", o.RoleName); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateShipTypeID(formats strfmt.Registry) error {

	if err := validate.Required("ship_type_id", "body", o.ShipTypeID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateSolarSystemID(formats strfmt.Registry) error {

	if err := validate.Required("solar_system_id", "body", o.SolarSystemID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateSquadID(formats strfmt.Registry) error {

	if err := validate.Required("squad_id", "body", o.SquadID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateTakesFleetWarp(formats strfmt.Registry) error {

	if err := validate.Required("takes_fleet_warp", "body", o.TakesFleetWarp); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDMembersOKBodyItems0) validateWingID(formats strfmt.Registry) error {

	if err := validate.Required("wing_id", "body", o.WingID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDMembersOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDMembersOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
