package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetFleetsFleetIDWingsReader is a Reader for the GetFleetsFleetIDWings structure.
type GetFleetsFleetIDWingsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFleetsFleetIDWingsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFleetsFleetIDWingsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetFleetsFleetIDWingsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetFleetsFleetIDWingsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetFleetsFleetIDWingsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFleetsFleetIDWingsOK creates a GetFleetsFleetIDWingsOK with default headers values
func NewGetFleetsFleetIDWingsOK() *GetFleetsFleetIDWingsOK {
	return &GetFleetsFleetIDWingsOK{}
}

/*GetFleetsFleetIDWingsOK handles this case with default header values.

A list of fleet wings
*/
type GetFleetsFleetIDWingsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetFleetsFleetIDWingsOKBodyItems0
}

func (o *GetFleetsFleetIDWingsOK) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/wings/][%d] getFleetsFleetIdWingsOK  %+v", 200, o.Payload)
}

func (o *GetFleetsFleetIDWingsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDWingsForbidden creates a GetFleetsFleetIDWingsForbidden with default headers values
func NewGetFleetsFleetIDWingsForbidden() *GetFleetsFleetIDWingsForbidden {
	return &GetFleetsFleetIDWingsForbidden{}
}

/*GetFleetsFleetIDWingsForbidden handles this case with default header values.

Forbidden
*/
type GetFleetsFleetIDWingsForbidden struct {
	Payload GetFleetsFleetIDWingsForbiddenBody
}

func (o *GetFleetsFleetIDWingsForbidden) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/wings/][%d] getFleetsFleetIdWingsForbidden  %+v", 403, o.Payload)
}

func (o *GetFleetsFleetIDWingsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDWingsNotFound creates a GetFleetsFleetIDWingsNotFound with default headers values
func NewGetFleetsFleetIDWingsNotFound() *GetFleetsFleetIDWingsNotFound {
	return &GetFleetsFleetIDWingsNotFound{}
}

/*GetFleetsFleetIDWingsNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type GetFleetsFleetIDWingsNotFound struct {
	Payload GetFleetsFleetIDWingsNotFoundBody
}

func (o *GetFleetsFleetIDWingsNotFound) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/wings/][%d] getFleetsFleetIdWingsNotFound  %+v", 404, o.Payload)
}

func (o *GetFleetsFleetIDWingsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDWingsInternalServerError creates a GetFleetsFleetIDWingsInternalServerError with default headers values
func NewGetFleetsFleetIDWingsInternalServerError() *GetFleetsFleetIDWingsInternalServerError {
	return &GetFleetsFleetIDWingsInternalServerError{}
}

/*GetFleetsFleetIDWingsInternalServerError handles this case with default header values.

Internal server error
*/
type GetFleetsFleetIDWingsInternalServerError struct {
	Payload GetFleetsFleetIDWingsInternalServerErrorBody
}

func (o *GetFleetsFleetIDWingsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/wings/][%d] getFleetsFleetIdWingsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFleetsFleetIDWingsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetFleetsFleetIDWingsForbiddenBody get_fleets_fleet_id_wings_forbidden
//
// Forbidden
swagger:model GetFleetsFleetIDWingsForbiddenBody
*/
type GetFleetsFleetIDWingsForbiddenBody struct {

	// get_fleets_fleet_id_wings_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID wings forbidden body
func (o *GetFleetsFleetIDWingsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDWingsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdWingsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDWingsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDWingsInternalServerErrorBody get_fleets_fleet_id_wings_internal_server_error
//
// Internal server error
swagger:model GetFleetsFleetIDWingsInternalServerErrorBody
*/
type GetFleetsFleetIDWingsInternalServerErrorBody struct {

	// get_fleets_fleet_id_wings_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID wings internal server error body
func (o *GetFleetsFleetIDWingsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDWingsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdWingsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDWingsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDWingsNotFoundBody get_fleets_fleet_id_wings_not_found
//
// Not found
swagger:model GetFleetsFleetIDWingsNotFoundBody
*/
type GetFleetsFleetIDWingsNotFoundBody struct {

	// get_fleets_fleet_id_wings_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get fleets fleet ID wings not found body
func (o *GetFleetsFleetIDWingsNotFoundBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDWingsNotFoundBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getFleetsFleetIdWingsNotFound"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsNotFoundBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsNotFoundBody) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDWingsNotFoundBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDWingsOKBodyItems0 get_fleets_fleet_id_wings_200_ok
//
// 200 ok object
swagger:model GetFleetsFleetIDWingsOKBodyItems0
*/
type GetFleetsFleetIDWingsOKBodyItems0 struct {

	// get_fleets_fleet_id_wings_id
	//
	// id integer
	// Required: true
	ID *int64 `json:"id"`

	// get_fleets_fleet_id_wings_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_fleets_fleet_id_wings_squads
	//
	// squads array
	// Required: true
	// Max Items: 25
	Squads []*GetFleetsFleetIDWingsOKBodyItems0SquadsItems0 `json:"squads"`
}

// Validate validates this get fleets fleet ID wings o k body items0
func (o *GetFleetsFleetIDWingsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateSquads(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDWingsOKBodyItems0) validateID(formats strfmt.Registry) error {

	if err := validate.Required("id", "body", o.ID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDWingsOKBodyItems0) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", o.Name); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDWingsOKBodyItems0) validateSquads(formats strfmt.Registry) error {

	if err := validate.Required("squads", "body", o.Squads); err != nil {
		return err
	}

	iSquadsSize := int64(len(o.Squads))

	if err := validate.MaxItems("squads", "body", iSquadsSize, 25); err != nil {
		return err
	}

	for i := 0; i < len(o.Squads); i++ {

		if swag.IsZero(o.Squads[i]) { // not required
			continue
		}

		if o.Squads[i] != nil {

			if err := o.Squads[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("squads" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDWingsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetFleetsFleetIDWingsOKBodyItems0SquadsItems0 get_fleets_fleet_id_wings_squad
//
// squad object
swagger:model GetFleetsFleetIDWingsOKBodyItems0SquadsItems0
*/
type GetFleetsFleetIDWingsOKBodyItems0SquadsItems0 struct {

	// get_fleets_fleet_id_wings_id
	//
	// id integer
	// Required: true
	ID *int64 `json:"id"`

	// get_fleets_fleet_id_wings_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`
}

// Validate validates this get fleets fleet ID wings o k body items0 squads items0
func (o *GetFleetsFleetIDWingsOKBodyItems0SquadsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetFleetsFleetIDWingsOKBodyItems0SquadsItems0) validateID(formats strfmt.Registry) error {

	if err := validate.Required("id", "body", o.ID); err != nil {
		return err
	}

	return nil
}

func (o *GetFleetsFleetIDWingsOKBodyItems0SquadsItems0) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", o.Name); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsOKBodyItems0SquadsItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetFleetsFleetIDWingsOKBodyItems0SquadsItems0) UnmarshalBinary(b []byte) error {
	var res GetFleetsFleetIDWingsOKBodyItems0SquadsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
