package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// PostFleetsFleetIDWingsWingIDSquadsReader is a Reader for the PostFleetsFleetIDWingsWingIDSquads structure.
type PostFleetsFleetIDWingsWingIDSquadsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostFleetsFleetIDWingsWingIDSquadsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 201:
		result := NewPostFleetsFleetIDWingsWingIDSquadsCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewPostFleetsFleetIDWingsWingIDSquadsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewPostFleetsFleetIDWingsWingIDSquadsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewPostFleetsFleetIDWingsWingIDSquadsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostFleetsFleetIDWingsWingIDSquadsCreated creates a PostFleetsFleetIDWingsWingIDSquadsCreated with default headers values
func NewPostFleetsFleetIDWingsWingIDSquadsCreated() *PostFleetsFleetIDWingsWingIDSquadsCreated {
	return &PostFleetsFleetIDWingsWingIDSquadsCreated{}
}

/*PostFleetsFleetIDWingsWingIDSquadsCreated handles this case with default header values.

Squad created
*/
type PostFleetsFleetIDWingsWingIDSquadsCreated struct {
	Payload PostFleetsFleetIDWingsWingIDSquadsCreatedBody
}

func (o *PostFleetsFleetIDWingsWingIDSquadsCreated) Error() string {
	return fmt.Sprintf("[POST /fleets/{fleet_id}/wings/{wing_id}/squads/][%d] postFleetsFleetIdWingsWingIdSquadsCreated  %+v", 201, o.Payload)
}

func (o *PostFleetsFleetIDWingsWingIDSquadsCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFleetsFleetIDWingsWingIDSquadsForbidden creates a PostFleetsFleetIDWingsWingIDSquadsForbidden with default headers values
func NewPostFleetsFleetIDWingsWingIDSquadsForbidden() *PostFleetsFleetIDWingsWingIDSquadsForbidden {
	return &PostFleetsFleetIDWingsWingIDSquadsForbidden{}
}

/*PostFleetsFleetIDWingsWingIDSquadsForbidden handles this case with default header values.

Forbidden
*/
type PostFleetsFleetIDWingsWingIDSquadsForbidden struct {
	Payload PostFleetsFleetIDWingsWingIDSquadsForbiddenBody
}

func (o *PostFleetsFleetIDWingsWingIDSquadsForbidden) Error() string {
	return fmt.Sprintf("[POST /fleets/{fleet_id}/wings/{wing_id}/squads/][%d] postFleetsFleetIdWingsWingIdSquadsForbidden  %+v", 403, o.Payload)
}

func (o *PostFleetsFleetIDWingsWingIDSquadsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFleetsFleetIDWingsWingIDSquadsNotFound creates a PostFleetsFleetIDWingsWingIDSquadsNotFound with default headers values
func NewPostFleetsFleetIDWingsWingIDSquadsNotFound() *PostFleetsFleetIDWingsWingIDSquadsNotFound {
	return &PostFleetsFleetIDWingsWingIDSquadsNotFound{}
}

/*PostFleetsFleetIDWingsWingIDSquadsNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type PostFleetsFleetIDWingsWingIDSquadsNotFound struct {
	Payload PostFleetsFleetIDWingsWingIDSquadsNotFoundBody
}

func (o *PostFleetsFleetIDWingsWingIDSquadsNotFound) Error() string {
	return fmt.Sprintf("[POST /fleets/{fleet_id}/wings/{wing_id}/squads/][%d] postFleetsFleetIdWingsWingIdSquadsNotFound  %+v", 404, o.Payload)
}

func (o *PostFleetsFleetIDWingsWingIDSquadsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostFleetsFleetIDWingsWingIDSquadsInternalServerError creates a PostFleetsFleetIDWingsWingIDSquadsInternalServerError with default headers values
func NewPostFleetsFleetIDWingsWingIDSquadsInternalServerError() *PostFleetsFleetIDWingsWingIDSquadsInternalServerError {
	return &PostFleetsFleetIDWingsWingIDSquadsInternalServerError{}
}

/*PostFleetsFleetIDWingsWingIDSquadsInternalServerError handles this case with default header values.

Internal server error
*/
type PostFleetsFleetIDWingsWingIDSquadsInternalServerError struct {
	Payload PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody
}

func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /fleets/{fleet_id}/wings/{wing_id}/squads/][%d] postFleetsFleetIdWingsWingIdSquadsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*PostFleetsFleetIDWingsWingIDSquadsCreatedBody post_fleets_fleet_id_wings_wing_id_squads_created
//
// 201 created object
swagger:model PostFleetsFleetIDWingsWingIDSquadsCreatedBody
*/
type PostFleetsFleetIDWingsWingIDSquadsCreatedBody struct {

	// post_fleets_fleet_id_wings_wing_id_squads_squad_id
	//
	// The squad_id of the newly created squad
	// Required: true
	SquadID *int64 `json:"squad_id"`
}

// Validate validates this post fleets fleet ID wings wing ID squads created body
func (o *PostFleetsFleetIDWingsWingIDSquadsCreatedBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateSquadID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostFleetsFleetIDWingsWingIDSquadsCreatedBody) validateSquadID(formats strfmt.Registry) error {

	if err := validate.Required("postFleetsFleetIdWingsWingIdSquadsCreated"+"."+"squad_id", "body", o.SquadID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsCreatedBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsCreatedBody) UnmarshalBinary(b []byte) error {
	var res PostFleetsFleetIDWingsWingIDSquadsCreatedBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostFleetsFleetIDWingsWingIDSquadsForbiddenBody post_fleets_fleet_id_wings_wing_id_squads_forbidden
//
// Forbidden
swagger:model PostFleetsFleetIDWingsWingIDSquadsForbiddenBody
*/
type PostFleetsFleetIDWingsWingIDSquadsForbiddenBody struct {

	// post_fleets_fleet_id_wings_wing_id_squads_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post fleets fleet ID wings wing ID squads forbidden body
func (o *PostFleetsFleetIDWingsWingIDSquadsForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostFleetsFleetIDWingsWingIDSquadsForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postFleetsFleetIdWingsWingIdSquadsForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsForbiddenBody) UnmarshalBinary(b []byte) error {
	var res PostFleetsFleetIDWingsWingIDSquadsForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody post_fleets_fleet_id_wings_wing_id_squads_internal_server_error
//
// Internal server error
swagger:model PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody
*/
type PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody struct {

	// post_fleets_fleet_id_wings_wing_id_squads_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post fleets fleet ID wings wing ID squads internal server error body
func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postFleetsFleetIdWingsWingIdSquadsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res PostFleetsFleetIDWingsWingIDSquadsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*PostFleetsFleetIDWingsWingIDSquadsNotFoundBody post_fleets_fleet_id_wings_wing_id_squads_not_found
//
// Not found
swagger:model PostFleetsFleetIDWingsWingIDSquadsNotFoundBody
*/
type PostFleetsFleetIDWingsWingIDSquadsNotFoundBody struct {

	// post_fleets_fleet_id_wings_wing_id_squads_404_not_found
	//
	// Not found message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this post fleets fleet ID wings wing ID squads not found body
func (o *PostFleetsFleetIDWingsWingIDSquadsNotFoundBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *PostFleetsFleetIDWingsWingIDSquadsNotFoundBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("postFleetsFleetIdWingsWingIdSquadsNotFound"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsNotFoundBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *PostFleetsFleetIDWingsWingIDSquadsNotFoundBody) UnmarshalBinary(b []byte) error {
	var res PostFleetsFleetIDWingsWingIDSquadsNotFoundBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
