package location

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDOnlineReader is a Reader for the GetCharactersCharacterIDOnline structure.
type GetCharactersCharacterIDOnlineReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDOnlineReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDOnlineOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDOnlineForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDOnlineInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDOnlineOK creates a GetCharactersCharacterIDOnlineOK with default headers values
func NewGetCharactersCharacterIDOnlineOK() *GetCharactersCharacterIDOnlineOK {
	return &GetCharactersCharacterIDOnlineOK{}
}

/*GetCharactersCharacterIDOnlineOK handles this case with default header values.

Boolean of if the character is currently online
*/
type GetCharactersCharacterIDOnlineOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload bool
}

func (o *GetCharactersCharacterIDOnlineOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/online/][%d] getCharactersCharacterIdOnlineOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDOnlineOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDOnlineForbidden creates a GetCharactersCharacterIDOnlineForbidden with default headers values
func NewGetCharactersCharacterIDOnlineForbidden() *GetCharactersCharacterIDOnlineForbidden {
	return &GetCharactersCharacterIDOnlineForbidden{}
}

/*GetCharactersCharacterIDOnlineForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDOnlineForbidden struct {
	Payload GetCharactersCharacterIDOnlineForbiddenBody
}

func (o *GetCharactersCharacterIDOnlineForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/online/][%d] getCharactersCharacterIdOnlineForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDOnlineForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDOnlineInternalServerError creates a GetCharactersCharacterIDOnlineInternalServerError with default headers values
func NewGetCharactersCharacterIDOnlineInternalServerError() *GetCharactersCharacterIDOnlineInternalServerError {
	return &GetCharactersCharacterIDOnlineInternalServerError{}
}

/*GetCharactersCharacterIDOnlineInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDOnlineInternalServerError struct {
	Payload GetCharactersCharacterIDOnlineInternalServerErrorBody
}

func (o *GetCharactersCharacterIDOnlineInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/online/][%d] getCharactersCharacterIdOnlineInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDOnlineInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDOnlineForbiddenBody get_characters_character_id_online_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDOnlineForbiddenBody
*/
type GetCharactersCharacterIDOnlineForbiddenBody struct {

	// get_characters_character_id_online_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID online forbidden body
func (o *GetCharactersCharacterIDOnlineForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDOnlineForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdOnlineForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDOnlineForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDOnlineForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDOnlineForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDOnlineInternalServerErrorBody get_characters_character_id_online_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDOnlineInternalServerErrorBody
*/
type GetCharactersCharacterIDOnlineInternalServerErrorBody struct {

	// get_characters_character_id_online_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID online internal server error body
func (o *GetCharactersCharacterIDOnlineInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDOnlineInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdOnlineInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDOnlineInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDOnlineInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDOnlineInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
