package loyalty

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetLoyaltyStoresCorporationIDOffersReader is a Reader for the GetLoyaltyStoresCorporationIDOffers structure.
type GetLoyaltyStoresCorporationIDOffersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetLoyaltyStoresCorporationIDOffersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetLoyaltyStoresCorporationIDOffersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetLoyaltyStoresCorporationIDOffersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetLoyaltyStoresCorporationIDOffersOK creates a GetLoyaltyStoresCorporationIDOffersOK with default headers values
func NewGetLoyaltyStoresCorporationIDOffersOK() *GetLoyaltyStoresCorporationIDOffersOK {
	return &GetLoyaltyStoresCorporationIDOffersOK{}
}

/*GetLoyaltyStoresCorporationIDOffersOK handles this case with default header values.

A list of offers
*/
type GetLoyaltyStoresCorporationIDOffersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetLoyaltyStoresCorporationIDOffersOKBodyItems0
}

func (o *GetLoyaltyStoresCorporationIDOffersOK) Error() string {
	return fmt.Sprintf("[GET /loyalty/stores/{corporation_id}/offers/][%d] getLoyaltyStoresCorporationIdOffersOK  %+v", 200, o.Payload)
}

func (o *GetLoyaltyStoresCorporationIDOffersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetLoyaltyStoresCorporationIDOffersInternalServerError creates a GetLoyaltyStoresCorporationIDOffersInternalServerError with default headers values
func NewGetLoyaltyStoresCorporationIDOffersInternalServerError() *GetLoyaltyStoresCorporationIDOffersInternalServerError {
	return &GetLoyaltyStoresCorporationIDOffersInternalServerError{}
}

/*GetLoyaltyStoresCorporationIDOffersInternalServerError handles this case with default header values.

Internal server error
*/
type GetLoyaltyStoresCorporationIDOffersInternalServerError struct {
	Payload GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody
}

func (o *GetLoyaltyStoresCorporationIDOffersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /loyalty/stores/{corporation_id}/offers/][%d] getLoyaltyStoresCorporationIdOffersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetLoyaltyStoresCorporationIDOffersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody get_loyalty_stores_corporation_id_offers_internal_server_error
//
// Internal server error
swagger:model GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody
*/
type GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody struct {

	// get_loyalty_stores_corporation_id_offers_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get loyalty stores corporation ID offers internal server error body
func (o *GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getLoyaltyStoresCorporationIdOffersInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetLoyaltyStoresCorporationIDOffersInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetLoyaltyStoresCorporationIDOffersOKBodyItems0 get_loyalty_stores_corporation_id_offers_200_ok
//
// 200 ok object
swagger:model GetLoyaltyStoresCorporationIDOffersOKBodyItems0
*/
type GetLoyaltyStoresCorporationIDOffersOKBodyItems0 struct {

	// get_loyalty_stores_corporation_id_offers_isk_cost
	//
	// isk_cost number
	// Required: true
	IskCost *int32 `json:"isk_cost"`

	// get_loyalty_stores_corporation_id_offers_lp_cost
	//
	// lp_cost integer
	// Required: true
	LpCost *int32 `json:"lp_cost"`

	// get_loyalty_stores_corporation_id_offers_offer_id
	//
	// offer_id integer
	// Required: true
	OfferID *int32 `json:"offer_id"`

	// get_loyalty_stores_corporation_id_offers_quantity
	//
	// quantity integer
	// Required: true
	Quantity *int32 `json:"quantity"`

	// get_loyalty_stores_corporation_id_offers_required_items
	//
	// required_items array
	// Required: true
	// Max Items: 100
	RequiredItems []*GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0 `json:"required_items"`

	// get_loyalty_stores_corporation_id_offers_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

// Validate validates this get loyalty stores corporation ID offers o k body items0
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateIskCost(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLpCost(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateOfferID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateQuantity(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRequiredItems(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTypeID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateIskCost(formats strfmt.Registry) error {

	if err := validate.Required("isk_cost", "body", o.IskCost); err != nil {
		return err
	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateLpCost(formats strfmt.Registry) error {

	if err := validate.Required("lp_cost", "body", o.LpCost); err != nil {
		return err
	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateOfferID(formats strfmt.Registry) error {

	if err := validate.Required("offer_id", "body", o.OfferID); err != nil {
		return err
	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateQuantity(formats strfmt.Registry) error {

	if err := validate.Required("quantity", "body", o.Quantity); err != nil {
		return err
	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateRequiredItems(formats strfmt.Registry) error {

	if err := validate.Required("required_items", "body", o.RequiredItems); err != nil {
		return err
	}

	iRequiredItemsSize := int64(len(o.RequiredItems))

	if err := validate.MaxItems("required_items", "body", iRequiredItemsSize, 100); err != nil {
		return err
	}

	for i := 0; i < len(o.RequiredItems); i++ {

		if swag.IsZero(o.RequiredItems[i]) { // not required
			continue
		}

		if o.RequiredItems[i] != nil {

			if err := o.RequiredItems[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("required_items" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) validateTypeID(formats strfmt.Registry) error {

	if err := validate.Required("type_id", "body", o.TypeID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetLoyaltyStoresCorporationIDOffersOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0 get_loyalty_stores_corporation_id_offers_required_item
//
// required_item object
swagger:model GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0
*/
type GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0 struct {

	// get_loyalty_stores_corporation_id_offers_quantity
	//
	// quantity integer
	// Required: true
	Quantity *int32 `json:"quantity"`

	// get_loyalty_stores_corporation_id_offers_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`
}

// Validate validates this get loyalty stores corporation ID offers o k body items0 required items items0
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateQuantity(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTypeID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0) validateQuantity(formats strfmt.Registry) error {

	if err := validate.Required("quantity", "body", o.Quantity); err != nil {
		return err
	}

	return nil
}

func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0) validateTypeID(formats strfmt.Registry) error {

	if err := validate.Required("type_id", "body", o.TypeID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0) UnmarshalBinary(b []byte) error {
	var res GetLoyaltyStoresCorporationIDOffersOKBodyItems0RequiredItemsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
