package market

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetMarketsGroupsReader is a Reader for the GetMarketsGroups structure.
type GetMarketsGroupsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetMarketsGroupsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetMarketsGroupsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetMarketsGroupsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetMarketsGroupsOK creates a GetMarketsGroupsOK with default headers values
func NewGetMarketsGroupsOK() *GetMarketsGroupsOK {
	return &GetMarketsGroupsOK{}
}

/*GetMarketsGroupsOK handles this case with default header values.

A list of item group ids
*/
type GetMarketsGroupsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetMarketsGroupsOK) Error() string {
	return fmt.Sprintf("[GET /markets/groups/][%d] getMarketsGroupsOK  %+v", 200, o.Payload)
}

func (o *GetMarketsGroupsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsGroupsInternalServerError creates a GetMarketsGroupsInternalServerError with default headers values
func NewGetMarketsGroupsInternalServerError() *GetMarketsGroupsInternalServerError {
	return &GetMarketsGroupsInternalServerError{}
}

/*GetMarketsGroupsInternalServerError handles this case with default header values.

Internal server error
*/
type GetMarketsGroupsInternalServerError struct {
	Payload GetMarketsGroupsInternalServerErrorBody
}

func (o *GetMarketsGroupsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /markets/groups/][%d] getMarketsGroupsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetMarketsGroupsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetMarketsGroupsInternalServerErrorBody get_markets_groups_internal_server_error
//
// Internal server error
swagger:model GetMarketsGroupsInternalServerErrorBody
*/
type GetMarketsGroupsInternalServerErrorBody struct {

	// get_markets_groups_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get markets groups internal server error body
func (o *GetMarketsGroupsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMarketsGroupsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getMarketsGroupsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetMarketsGroupsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetMarketsGroupsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetMarketsGroupsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
