package market

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetMarketsStructuresStructureIDReader is a Reader for the GetMarketsStructuresStructureID structure.
type GetMarketsStructuresStructureIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetMarketsStructuresStructureIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetMarketsStructuresStructureIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetMarketsStructuresStructureIDForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetMarketsStructuresStructureIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetMarketsStructuresStructureIDOK creates a GetMarketsStructuresStructureIDOK with default headers values
func NewGetMarketsStructuresStructureIDOK() *GetMarketsStructuresStructureIDOK {
	return &GetMarketsStructuresStructureIDOK{}
}

/*GetMarketsStructuresStructureIDOK handles this case with default header values.

A list of orders
*/
type GetMarketsStructuresStructureIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetMarketsStructuresStructureIDOKBodyItems0
}

func (o *GetMarketsStructuresStructureIDOK) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdOK  %+v", 200, o.Payload)
}

func (o *GetMarketsStructuresStructureIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsStructuresStructureIDForbidden creates a GetMarketsStructuresStructureIDForbidden with default headers values
func NewGetMarketsStructuresStructureIDForbidden() *GetMarketsStructuresStructureIDForbidden {
	return &GetMarketsStructuresStructureIDForbidden{}
}

/*GetMarketsStructuresStructureIDForbidden handles this case with default header values.

Forbidden
*/
type GetMarketsStructuresStructureIDForbidden struct {
	Payload GetMarketsStructuresStructureIDForbiddenBody
}

func (o *GetMarketsStructuresStructureIDForbidden) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdForbidden  %+v", 403, o.Payload)
}

func (o *GetMarketsStructuresStructureIDForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMarketsStructuresStructureIDInternalServerError creates a GetMarketsStructuresStructureIDInternalServerError with default headers values
func NewGetMarketsStructuresStructureIDInternalServerError() *GetMarketsStructuresStructureIDInternalServerError {
	return &GetMarketsStructuresStructureIDInternalServerError{}
}

/*GetMarketsStructuresStructureIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetMarketsStructuresStructureIDInternalServerError struct {
	Payload GetMarketsStructuresStructureIDInternalServerErrorBody
}

func (o *GetMarketsStructuresStructureIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /markets/structures/{structure_id}/][%d] getMarketsStructuresStructureIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetMarketsStructuresStructureIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetMarketsStructuresStructureIDForbiddenBody get_markets_structures_structure_id_forbidden
//
// Forbidden
swagger:model GetMarketsStructuresStructureIDForbiddenBody
*/
type GetMarketsStructuresStructureIDForbiddenBody struct {

	// get_markets_structures_structure_id_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get markets structures structure ID forbidden body
func (o *GetMarketsStructuresStructureIDForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMarketsStructuresStructureIDForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getMarketsStructuresStructureIdForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetMarketsStructuresStructureIDForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetMarketsStructuresStructureIDInternalServerErrorBody get_markets_structures_structure_id_internal_server_error
//
// Internal server error
swagger:model GetMarketsStructuresStructureIDInternalServerErrorBody
*/
type GetMarketsStructuresStructureIDInternalServerErrorBody struct {

	// get_markets_structures_structure_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get markets structures structure ID internal server error body
func (o *GetMarketsStructuresStructureIDInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMarketsStructuresStructureIDInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getMarketsStructuresStructureIdInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetMarketsStructuresStructureIDInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetMarketsStructuresStructureIDOKBodyItems0 get_markets_structures_structure_id_200_ok
//
// 200 ok object
swagger:model GetMarketsStructuresStructureIDOKBodyItems0
*/
type GetMarketsStructuresStructureIDOKBodyItems0 struct {

	// get_markets_structures_structure_id_duration
	//
	// duration integer
	// Required: true
	Duration *int32 `json:"duration"`

	// get_markets_structures_structure_id_is_buy_order
	//
	// is_buy_order boolean
	// Required: true
	IsBuyOrder *bool `json:"is_buy_order"`

	// get_markets_structures_structure_id_issued
	//
	// issued string
	// Required: true
	Issued *strfmt.DateTime `json:"issued"`

	// get_markets_structures_structure_id_location_id
	//
	// location_id integer
	// Required: true
	LocationID *int64 `json:"location_id"`

	// get_markets_structures_structure_id_min_volume
	//
	// min_volume integer
	// Required: true
	MinVolume *int32 `json:"min_volume"`

	// get_markets_structures_structure_id_order_id
	//
	// order_id integer
	// Required: true
	OrderID *int64 `json:"order_id"`

	// get_markets_structures_structure_id_price
	//
	// price number
	// Required: true
	Price *float32 `json:"price"`

	// get_markets_structures_structure_id_range
	//
	// range string
	// Required: true
	Range *string `json:"range"`

	// get_markets_structures_structure_id_type_id
	//
	// type_id integer
	// Required: true
	TypeID *int32 `json:"type_id"`

	// get_markets_structures_structure_id_volume_remain
	//
	// volume_remain integer
	// Required: true
	VolumeRemain *int32 `json:"volume_remain"`

	// get_markets_structures_structure_id_volume_total
	//
	// volume_total integer
	// Required: true
	VolumeTotal *int32 `json:"volume_total"`
}

// Validate validates this get markets structures structure ID o k body items0
func (o *GetMarketsStructuresStructureIDOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateDuration(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateIsBuyOrder(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateIssued(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateLocationID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateMinVolume(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateOrderID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validatePrice(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRange(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTypeID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateVolumeRemain(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateVolumeTotal(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateDuration(formats strfmt.Registry) error {

	if err := validate.Required("duration", "body", o.Duration); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateIsBuyOrder(formats strfmt.Registry) error {

	if err := validate.Required("is_buy_order", "body", o.IsBuyOrder); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateIssued(formats strfmt.Registry) error {

	if err := validate.Required("issued", "body", o.Issued); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateLocationID(formats strfmt.Registry) error {

	if err := validate.Required("location_id", "body", o.LocationID); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateMinVolume(formats strfmt.Registry) error {

	if err := validate.Required("min_volume", "body", o.MinVolume); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateOrderID(formats strfmt.Registry) error {

	if err := validate.Required("order_id", "body", o.OrderID); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validatePrice(formats strfmt.Registry) error {

	if err := validate.Required("price", "body", o.Price); err != nil {
		return err
	}

	return nil
}

var getMarketsStructuresStructureIdOKBodyItems0TypeRangePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["station","region","solarsystem","1","2","3","4","5","10","20","30","40"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		getMarketsStructuresStructureIdOKBodyItems0TypeRangePropEnum = append(getMarketsStructuresStructureIdOKBodyItems0TypeRangePropEnum, v)
	}
}

const (
	// GetMarketsStructuresStructureIDOKBodyItems0RangeStation captures enum value "station"
	GetMarketsStructuresStructureIDOKBodyItems0RangeStation string = "station"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeRegion captures enum value "region"
	GetMarketsStructuresStructureIDOKBodyItems0RangeRegion string = "region"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeSolarsystem captures enum value "solarsystem"
	GetMarketsStructuresStructureIDOKBodyItems0RangeSolarsystem string = "solarsystem"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr1 captures enum value "1"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr1 string = "1"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr2 captures enum value "2"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr2 string = "2"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr3 captures enum value "3"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr3 string = "3"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr4 captures enum value "4"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr4 string = "4"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr5 captures enum value "5"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr5 string = "5"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr10 captures enum value "10"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr10 string = "10"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr20 captures enum value "20"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr20 string = "20"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr30 captures enum value "30"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr30 string = "30"
	// GetMarketsStructuresStructureIDOKBodyItems0RangeNr40 captures enum value "40"
	GetMarketsStructuresStructureIDOKBodyItems0RangeNr40 string = "40"
)

// prop value enum
func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateRangeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, getMarketsStructuresStructureIdOKBodyItems0TypeRangePropEnum); err != nil {
		return err
	}
	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateRange(formats strfmt.Registry) error {

	if err := validate.Required("range", "body", o.Range); err != nil {
		return err
	}

	// value enum
	if err := o.validateRangeEnum("range", "body", *o.Range); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateTypeID(formats strfmt.Registry) error {

	if err := validate.Required("type_id", "body", o.TypeID); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateVolumeRemain(formats strfmt.Registry) error {

	if err := validate.Required("volume_remain", "body", o.VolumeRemain); err != nil {
		return err
	}

	return nil
}

func (o *GetMarketsStructuresStructureIDOKBodyItems0) validateVolumeTotal(formats strfmt.Registry) error {

	if err := validate.Required("volume_total", "body", o.VolumeTotal); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetMarketsStructuresStructureIDOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetMarketsStructuresStructureIDOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
