package opportunities

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetCharactersCharacterIDOpportunitiesReader is a Reader for the GetCharactersCharacterIDOpportunities structure.
type GetCharactersCharacterIDOpportunitiesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCharactersCharacterIDOpportunitiesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetCharactersCharacterIDOpportunitiesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetCharactersCharacterIDOpportunitiesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetCharactersCharacterIDOpportunitiesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCharactersCharacterIDOpportunitiesOK creates a GetCharactersCharacterIDOpportunitiesOK with default headers values
func NewGetCharactersCharacterIDOpportunitiesOK() *GetCharactersCharacterIDOpportunitiesOK {
	return &GetCharactersCharacterIDOpportunitiesOK{}
}

/*GetCharactersCharacterIDOpportunitiesOK handles this case with default header values.

A list of opportunities task ids
*/
type GetCharactersCharacterIDOpportunitiesOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetCharactersCharacterIDOpportunitiesOKBodyItems0
}

func (o *GetCharactersCharacterIDOpportunitiesOK) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/opportunities/][%d] getCharactersCharacterIdOpportunitiesOK  %+v", 200, o.Payload)
}

func (o *GetCharactersCharacterIDOpportunitiesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDOpportunitiesForbidden creates a GetCharactersCharacterIDOpportunitiesForbidden with default headers values
func NewGetCharactersCharacterIDOpportunitiesForbidden() *GetCharactersCharacterIDOpportunitiesForbidden {
	return &GetCharactersCharacterIDOpportunitiesForbidden{}
}

/*GetCharactersCharacterIDOpportunitiesForbidden handles this case with default header values.

Forbidden
*/
type GetCharactersCharacterIDOpportunitiesForbidden struct {
	Payload GetCharactersCharacterIDOpportunitiesForbiddenBody
}

func (o *GetCharactersCharacterIDOpportunitiesForbidden) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/opportunities/][%d] getCharactersCharacterIdOpportunitiesForbidden  %+v", 403, o.Payload)
}

func (o *GetCharactersCharacterIDOpportunitiesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCharactersCharacterIDOpportunitiesInternalServerError creates a GetCharactersCharacterIDOpportunitiesInternalServerError with default headers values
func NewGetCharactersCharacterIDOpportunitiesInternalServerError() *GetCharactersCharacterIDOpportunitiesInternalServerError {
	return &GetCharactersCharacterIDOpportunitiesInternalServerError{}
}

/*GetCharactersCharacterIDOpportunitiesInternalServerError handles this case with default header values.

Internal server error
*/
type GetCharactersCharacterIDOpportunitiesInternalServerError struct {
	Payload GetCharactersCharacterIDOpportunitiesInternalServerErrorBody
}

func (o *GetCharactersCharacterIDOpportunitiesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /characters/{character_id}/opportunities/][%d] getCharactersCharacterIdOpportunitiesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCharactersCharacterIDOpportunitiesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetCharactersCharacterIDOpportunitiesForbiddenBody get_characters_character_id_opportunities_forbidden
//
// Forbidden
swagger:model GetCharactersCharacterIDOpportunitiesForbiddenBody
*/
type GetCharactersCharacterIDOpportunitiesForbiddenBody struct {

	// get_characters_character_id_opportunities_403_forbidden
	//
	// Forbidden message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID opportunities forbidden body
func (o *GetCharactersCharacterIDOpportunitiesForbiddenBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDOpportunitiesForbiddenBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdOpportunitiesForbidden"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesForbiddenBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesForbiddenBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDOpportunitiesForbiddenBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDOpportunitiesInternalServerErrorBody get_characters_character_id_opportunities_internal_server_error
//
// Internal server error
swagger:model GetCharactersCharacterIDOpportunitiesInternalServerErrorBody
*/
type GetCharactersCharacterIDOpportunitiesInternalServerErrorBody struct {

	// get_characters_character_id_opportunities_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get characters character ID opportunities internal server error body
func (o *GetCharactersCharacterIDOpportunitiesInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDOpportunitiesInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getCharactersCharacterIdOpportunitiesInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDOpportunitiesInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetCharactersCharacterIDOpportunitiesOKBodyItems0 get_characters_character_id_opportunities_200_ok
//
// 200 ok object
swagger:model GetCharactersCharacterIDOpportunitiesOKBodyItems0
*/
type GetCharactersCharacterIDOpportunitiesOKBodyItems0 struct {

	// get_characters_character_id_opportunities_completed_at
	//
	// completed_at string
	// Required: true
	CompletedAt *strfmt.DateTime `json:"completed_at"`

	// get_characters_character_id_opportunities_task_id
	//
	// task_id integer
	// Required: true
	TaskID *int32 `json:"task_id"`
}

// Validate validates this get characters character ID opportunities o k body items0
func (o *GetCharactersCharacterIDOpportunitiesOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateCompletedAt(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateTaskID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetCharactersCharacterIDOpportunitiesOKBodyItems0) validateCompletedAt(formats strfmt.Registry) error {

	if err := validate.Required("completed_at", "body", o.CompletedAt); err != nil {
		return err
	}

	return nil
}

func (o *GetCharactersCharacterIDOpportunitiesOKBodyItems0) validateTaskID(formats strfmt.Registry) error {

	if err := validate.Required("task_id", "body", o.TaskID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetCharactersCharacterIDOpportunitiesOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetCharactersCharacterIDOpportunitiesOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
