package opportunities

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetOpportunitiesGroupsGroupIDReader is a Reader for the GetOpportunitiesGroupsGroupID structure.
type GetOpportunitiesGroupsGroupIDReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOpportunitiesGroupsGroupIDReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetOpportunitiesGroupsGroupIDOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetOpportunitiesGroupsGroupIDInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetOpportunitiesGroupsGroupIDOK creates a GetOpportunitiesGroupsGroupIDOK with default headers values
func NewGetOpportunitiesGroupsGroupIDOK() *GetOpportunitiesGroupsGroupIDOK {
	return &GetOpportunitiesGroupsGroupIDOK{}
}

/*GetOpportunitiesGroupsGroupIDOK handles this case with default header values.

Details of an opportunities group
*/
type GetOpportunitiesGroupsGroupIDOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload GetOpportunitiesGroupsGroupIDOKBody
}

func (o *GetOpportunitiesGroupsGroupIDOK) Error() string {
	return fmt.Sprintf("[GET /opportunities/groups/{group_id}/][%d] getOpportunitiesGroupsGroupIdOK  %+v", 200, o.Payload)
}

func (o *GetOpportunitiesGroupsGroupIDOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOpportunitiesGroupsGroupIDInternalServerError creates a GetOpportunitiesGroupsGroupIDInternalServerError with default headers values
func NewGetOpportunitiesGroupsGroupIDInternalServerError() *GetOpportunitiesGroupsGroupIDInternalServerError {
	return &GetOpportunitiesGroupsGroupIDInternalServerError{}
}

/*GetOpportunitiesGroupsGroupIDInternalServerError handles this case with default header values.

Internal server error
*/
type GetOpportunitiesGroupsGroupIDInternalServerError struct {
	Payload GetOpportunitiesGroupsGroupIDInternalServerErrorBody
}

func (o *GetOpportunitiesGroupsGroupIDInternalServerError) Error() string {
	return fmt.Sprintf("[GET /opportunities/groups/{group_id}/][%d] getOpportunitiesGroupsGroupIdInternalServerError  %+v", 500, o.Payload)
}

func (o *GetOpportunitiesGroupsGroupIDInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetOpportunitiesGroupsGroupIDInternalServerErrorBody get_opportunities_groups_group_id_internal_server_error
//
// Internal server error
swagger:model GetOpportunitiesGroupsGroupIDInternalServerErrorBody
*/
type GetOpportunitiesGroupsGroupIDInternalServerErrorBody struct {

	// get_opportunities_groups_group_id_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get opportunities groups group ID internal server error body
func (o *GetOpportunitiesGroupsGroupIDInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetOpportunitiesGroupsGroupIDInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetOpportunitiesGroupsGroupIDInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetOpportunitiesGroupsGroupIDInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetOpportunitiesGroupsGroupIDInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetOpportunitiesGroupsGroupIDOKBody get_opportunities_groups_group_id_ok
//
// 200 ok object
swagger:model GetOpportunitiesGroupsGroupIDOKBody
*/
type GetOpportunitiesGroupsGroupIDOKBody struct {

	// get_opportunities_groups_group_id_connected_groups
	//
	// The groups that are connected to this group on the opportunities map
	// Required: true
	// Max Items: 50
	ConnectedGroups []int32 `json:"connected_groups"`

	// get_opportunities_groups_group_id_description
	//
	// description string
	// Required: true
	Description *string `json:"description"`

	// get_opportunities_groups_group_id_group_id
	//
	// group_id integer
	// Required: true
	GroupID *int32 `json:"group_id"`

	// get_opportunities_groups_group_id_name
	//
	// name string
	// Required: true
	Name *string `json:"name"`

	// get_opportunities_groups_group_id_notification
	//
	// notification string
	// Required: true
	Notification *string `json:"notification"`

	// get_opportunities_groups_group_id_required_tasks
	//
	// Tasks need to complete for this group
	// Required: true
	// Max Items: 100
	RequiredTasks []int32 `json:"required_tasks"`
}

// Validate validates this get opportunities groups group ID o k body
func (o *GetOpportunitiesGroupsGroupIDOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateConnectedGroups(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateDescription(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateGroupID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateName(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateNotification(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateRequiredTasks(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateConnectedGroups(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"connected_groups", "body", o.ConnectedGroups); err != nil {
		return err
	}

	iConnectedGroupsSize := int64(len(o.ConnectedGroups))

	if err := validate.MaxItems("getOpportunitiesGroupsGroupIdOK"+"."+"connected_groups", "body", iConnectedGroupsSize, 50); err != nil {
		return err
	}

	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateDescription(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"description", "body", o.Description); err != nil {
		return err
	}

	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateGroupID(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"group_id", "body", o.GroupID); err != nil {
		return err
	}

	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateName(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"name", "body", o.Name); err != nil {
		return err
	}

	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateNotification(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"notification", "body", o.Notification); err != nil {
		return err
	}

	return nil
}

func (o *GetOpportunitiesGroupsGroupIDOKBody) validateRequiredTasks(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsGroupIdOK"+"."+"required_tasks", "body", o.RequiredTasks); err != nil {
		return err
	}

	iRequiredTasksSize := int64(len(o.RequiredTasks))

	if err := validate.MaxItems("getOpportunitiesGroupsGroupIdOK"+"."+"required_tasks", "body", iRequiredTasksSize, 100); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetOpportunitiesGroupsGroupIDOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetOpportunitiesGroupsGroupIDOKBody) UnmarshalBinary(b []byte) error {
	var res GetOpportunitiesGroupsGroupIDOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
