package opportunities

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetOpportunitiesGroupsReader is a Reader for the GetOpportunitiesGroups structure.
type GetOpportunitiesGroupsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOpportunitiesGroupsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetOpportunitiesGroupsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetOpportunitiesGroupsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetOpportunitiesGroupsOK creates a GetOpportunitiesGroupsOK with default headers values
func NewGetOpportunitiesGroupsOK() *GetOpportunitiesGroupsOK {
	return &GetOpportunitiesGroupsOK{}
}

/*GetOpportunitiesGroupsOK handles this case with default header values.

A list of opportunities group ids
*/
type GetOpportunitiesGroupsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []int32
}

func (o *GetOpportunitiesGroupsOK) Error() string {
	return fmt.Sprintf("[GET /opportunities/groups/][%d] getOpportunitiesGroupsOK  %+v", 200, o.Payload)
}

func (o *GetOpportunitiesGroupsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOpportunitiesGroupsInternalServerError creates a GetOpportunitiesGroupsInternalServerError with default headers values
func NewGetOpportunitiesGroupsInternalServerError() *GetOpportunitiesGroupsInternalServerError {
	return &GetOpportunitiesGroupsInternalServerError{}
}

/*GetOpportunitiesGroupsInternalServerError handles this case with default header values.

Internal server error
*/
type GetOpportunitiesGroupsInternalServerError struct {
	Payload GetOpportunitiesGroupsInternalServerErrorBody
}

func (o *GetOpportunitiesGroupsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /opportunities/groups/][%d] getOpportunitiesGroupsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetOpportunitiesGroupsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetOpportunitiesGroupsInternalServerErrorBody get_opportunities_groups_internal_server_error
//
// Internal server error
swagger:model GetOpportunitiesGroupsInternalServerErrorBody
*/
type GetOpportunitiesGroupsInternalServerErrorBody struct {

	// get_opportunities_groups_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get opportunities groups internal server error body
func (o *GetOpportunitiesGroupsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetOpportunitiesGroupsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getOpportunitiesGroupsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetOpportunitiesGroupsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetOpportunitiesGroupsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetOpportunitiesGroupsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
