package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseSystemJumpsReader is a Reader for the GetUniverseSystemJumps structure.
type GetUniverseSystemJumpsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseSystemJumpsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseSystemJumpsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetUniverseSystemJumpsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseSystemJumpsOK creates a GetUniverseSystemJumpsOK with default headers values
func NewGetUniverseSystemJumpsOK() *GetUniverseSystemJumpsOK {
	return &GetUniverseSystemJumpsOK{}
}

/*GetUniverseSystemJumpsOK handles this case with default header values.

A list of systems and number of jumps
*/
type GetUniverseSystemJumpsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetUniverseSystemJumpsOKBodyItems0
}

func (o *GetUniverseSystemJumpsOK) Error() string {
	return fmt.Sprintf("[GET /universe/system_jumps/][%d] getUniverseSystemJumpsOK  %+v", 200, o.Payload)
}

func (o *GetUniverseSystemJumpsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseSystemJumpsInternalServerError creates a GetUniverseSystemJumpsInternalServerError with default headers values
func NewGetUniverseSystemJumpsInternalServerError() *GetUniverseSystemJumpsInternalServerError {
	return &GetUniverseSystemJumpsInternalServerError{}
}

/*GetUniverseSystemJumpsInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseSystemJumpsInternalServerError struct {
	Payload GetUniverseSystemJumpsInternalServerErrorBody
}

func (o *GetUniverseSystemJumpsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/system_jumps/][%d] getUniverseSystemJumpsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseSystemJumpsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseSystemJumpsInternalServerErrorBody get_universe_system_jumps_internal_server_error
//
// Internal server error
swagger:model GetUniverseSystemJumpsInternalServerErrorBody
*/
type GetUniverseSystemJumpsInternalServerErrorBody struct {

	// get_universe_system_jumps_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get universe system jumps internal server error body
func (o *GetUniverseSystemJumpsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetUniverseSystemJumpsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getUniverseSystemJumpsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetUniverseSystemJumpsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetUniverseSystemJumpsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetUniverseSystemJumpsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetUniverseSystemJumpsOKBodyItems0 get_universe_system_jumps_200_ok
//
// 200 ok object
swagger:model GetUniverseSystemJumpsOKBodyItems0
*/
type GetUniverseSystemJumpsOKBodyItems0 struct {

	// get_universe_system_jumps_ship_jumps
	//
	// ship_jumps integer
	// Required: true
	ShipJumps *int32 `json:"ship_jumps"`

	// get_universe_system_jumps_system_id
	//
	// system_id integer
	// Required: true
	SystemID *int32 `json:"system_id"`
}

// Validate validates this get universe system jumps o k body items0
func (o *GetUniverseSystemJumpsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateShipJumps(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateSystemID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetUniverseSystemJumpsOKBodyItems0) validateShipJumps(formats strfmt.Registry) error {

	if err := validate.Required("ship_jumps", "body", o.ShipJumps); err != nil {
		return err
	}

	return nil
}

func (o *GetUniverseSystemJumpsOKBodyItems0) validateSystemID(formats strfmt.Registry) error {

	if err := validate.Required("system_id", "body", o.SystemID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetUniverseSystemJumpsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetUniverseSystemJumpsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetUniverseSystemJumpsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
