package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"

	strfmt "github.com/go-openapi/strfmt"
)

// GetUniverseSystemKillsReader is a Reader for the GetUniverseSystemKills structure.
type GetUniverseSystemKillsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetUniverseSystemKillsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetUniverseSystemKillsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 500:
		result := NewGetUniverseSystemKillsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetUniverseSystemKillsOK creates a GetUniverseSystemKillsOK with default headers values
func NewGetUniverseSystemKillsOK() *GetUniverseSystemKillsOK {
	return &GetUniverseSystemKillsOK{}
}

/*GetUniverseSystemKillsOK handles this case with default header values.

A list of systems and number of ship, pod and NPC kills
*/
type GetUniverseSystemKillsOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload []*GetUniverseSystemKillsOKBodyItems0
}

func (o *GetUniverseSystemKillsOK) Error() string {
	return fmt.Sprintf("[GET /universe/system_kills/][%d] getUniverseSystemKillsOK  %+v", 200, o.Payload)
}

func (o *GetUniverseSystemKillsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetUniverseSystemKillsInternalServerError creates a GetUniverseSystemKillsInternalServerError with default headers values
func NewGetUniverseSystemKillsInternalServerError() *GetUniverseSystemKillsInternalServerError {
	return &GetUniverseSystemKillsInternalServerError{}
}

/*GetUniverseSystemKillsInternalServerError handles this case with default header values.

Internal server error
*/
type GetUniverseSystemKillsInternalServerError struct {
	Payload GetUniverseSystemKillsInternalServerErrorBody
}

func (o *GetUniverseSystemKillsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /universe/system_kills/][%d] getUniverseSystemKillsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetUniverseSystemKillsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

/*GetUniverseSystemKillsInternalServerErrorBody get_universe_system_kills_internal_server_error
//
// Internal server error
swagger:model GetUniverseSystemKillsInternalServerErrorBody
*/
type GetUniverseSystemKillsInternalServerErrorBody struct {

	// get_universe_system_kills_500_internal_server_error
	//
	// Internal server error message
	// Required: true
	Error *string `json:"error"`
}

// Validate validates this get universe system kills internal server error body
func (o *GetUniverseSystemKillsInternalServerErrorBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateError(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetUniverseSystemKillsInternalServerErrorBody) validateError(formats strfmt.Registry) error {

	if err := validate.Required("getUniverseSystemKillsInternalServerError"+"."+"error", "body", o.Error); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetUniverseSystemKillsInternalServerErrorBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetUniverseSystemKillsInternalServerErrorBody) UnmarshalBinary(b []byte) error {
	var res GetUniverseSystemKillsInternalServerErrorBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}

/*GetUniverseSystemKillsOKBodyItems0 get_universe_system_kills_200_ok
//
// 200 ok object
swagger:model GetUniverseSystemKillsOKBodyItems0
*/
type GetUniverseSystemKillsOKBodyItems0 struct {

	// get_universe_system_kills_npc_kills
	//
	// Number of NPC ships killed in this system
	// Required: true
	NpcKills *int32 `json:"npc_kills"`

	// get_universe_system_kills_pod_kills
	//
	// Number of pods killed in this system
	// Required: true
	PodKills *int32 `json:"pod_kills"`

	// get_universe_system_kills_ship_kills
	//
	// Number of player and NPC ships killed in this system
	// Required: true
	ShipKills *int32 `json:"ship_kills"`

	// get_universe_system_kills_system_id
	//
	// system_id integer
	// Required: true
	SystemID *int32 `json:"system_id"`
}

// Validate validates this get universe system kills o k body items0
func (o *GetUniverseSystemKillsOKBodyItems0) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateNpcKills(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validatePodKills(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateShipKills(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if err := o.validateSystemID(formats); err != nil {
		// prop
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *GetUniverseSystemKillsOKBodyItems0) validateNpcKills(formats strfmt.Registry) error {

	if err := validate.Required("npc_kills", "body", o.NpcKills); err != nil {
		return err
	}

	return nil
}

func (o *GetUniverseSystemKillsOKBodyItems0) validatePodKills(formats strfmt.Registry) error {

	if err := validate.Required("pod_kills", "body", o.PodKills); err != nil {
		return err
	}

	return nil
}

func (o *GetUniverseSystemKillsOKBodyItems0) validateShipKills(formats strfmt.Registry) error {

	if err := validate.Required("ship_kills", "body", o.ShipKills); err != nil {
		return err
	}

	return nil
}

func (o *GetUniverseSystemKillsOKBodyItems0) validateSystemID(formats strfmt.Registry) error {

	if err := validate.Required("system_id", "body", o.SystemID); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (o *GetUniverseSystemKillsOKBodyItems0) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *GetUniverseSystemKillsOKBodyItems0) UnmarshalBinary(b []byte) error {
	var res GetUniverseSystemKillsOKBodyItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
