package wallet

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetCharactersCharacterIDWalletsJournalParams creates a new GetCharactersCharacterIDWalletsJournalParams object
// with the default values initialized.
func NewGetCharactersCharacterIDWalletsJournalParams() *GetCharactersCharacterIDWalletsJournalParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDWalletsJournalParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCharactersCharacterIDWalletsJournalParamsWithTimeout creates a new GetCharactersCharacterIDWalletsJournalParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCharactersCharacterIDWalletsJournalParamsWithTimeout(timeout time.Duration) *GetCharactersCharacterIDWalletsJournalParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDWalletsJournalParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetCharactersCharacterIDWalletsJournalParamsWithContext creates a new GetCharactersCharacterIDWalletsJournalParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCharactersCharacterIDWalletsJournalParamsWithContext(ctx context.Context) *GetCharactersCharacterIDWalletsJournalParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDWalletsJournalParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetCharactersCharacterIDWalletsJournalParamsWithHTTPClient creates a new GetCharactersCharacterIDWalletsJournalParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetCharactersCharacterIDWalletsJournalParamsWithHTTPClient(client *http.Client) *GetCharactersCharacterIDWalletsJournalParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDWalletsJournalParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetCharactersCharacterIDWalletsJournalParams contains all the parameters to send to the API endpoint
for the get characters character id wallets journal operation typically these are written to a http.Request
*/
type GetCharactersCharacterIDWalletsJournalParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FromID
	  Only show journal entries happened before the transaction referenced by this id

	*/
	FromID *int64
	/*Token
	  Access token to use, if preferred over a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithTimeout(timeout time.Duration) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithContext(ctx context.Context) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithHTTPClient(client *http.Client) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithXUserAgent(xUserAgent *string) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCharacterID adds the characterID to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithCharacterID(characterID int32) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithDatasource adds the datasource to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithDatasource(datasource *string) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFromID adds the fromID to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithFromID(fromID *int64) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetFromID(fromID)
	return o
}

// SetFromID adds the fromId to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetFromID(fromID *int64) {
	o.FromID = fromID
}

// WithToken adds the token to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithToken(token *string) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) WithUserAgent(userAgent *string) *GetCharactersCharacterIDWalletsJournalParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get characters character id wallets journal params
func (o *GetCharactersCharacterIDWalletsJournalParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetCharactersCharacterIDWalletsJournalParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.FromID != nil {

		// query param from_id
		var qrFromID int64
		if o.FromID != nil {
			qrFromID = *o.FromID
		}
		qFromID := swag.FormatInt64(qrFromID)
		if qFromID != "" {
			if err := r.SetQueryParam("from_id", qFromID); err != nil {
				return err
			}
		}

	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
